/*
   This is part of rtl8187 OpenSource driver - v 0.1
   Copyright (C) Andrea Merello 2005  <andreamrl@tiscali.it> 
   Released under the terms of GPL (General Public License)
   
   
   Parts of this driver are based on the rtl8180 driver skeleton 
   from Patric Schenke & Andres Salomon.

   Parts of this driver are based on the Intel Pro Wireless 2*00 GPL drivers.
   
   some ideas might be derived from David Young rtl8180 netbsd driver.
   
   Parts of the usb code are from the r8150.c driver in linux kernel
   
   Some ideas borrowed from the 8139too.c driver included in linux kernel.
   
   We (I?) want to thanks the Authors of those projecs and also the 
   Ndiswrapper's project Authors.
   
   A special big thanks goes also to Realtek corp. for their help in my 
   attempt to add RTL8187 and RTL8225 support, and to David Young also. 

	- Please note that this file is a modified version from rtl8180-sa2400 
	drv. So some other people have contributed to this project, and they are
	thanked in the rtl8180-sa2400 CHANGELOG.
*/

#ifndef CONFIG_FORCE_HARD_FLOAT
double __floatsidf (int i) { return i; }
unsigned int __fixunsdfsi (double d) { return d; }
double __adddf3(double a, double b) { return a+b; }
double __addsf3(float a, float b) { return a+b; }
double __subdf3(double a, double b) { return a-b; }
double __extendsfdf2(float a) {return a;}
#endif

#undef LOOP_TEST
#undef DUMP_RX
#undef DUMP_TX
#undef DEBUG_TX_DESC2
#undef RX_DONT_PASS_UL
#undef DEBUG_EPROM
#undef DEBUG_RX_VERBOSE
#undef DUMMY_RX
#undef DEBUG_ZERO_RX
#undef DEBUG_RX_SKB
#undef DEBUG_TX_FRAG
#undef DEBUG_RX_FRAG
#undef DEBUG_TX_FILLDESC
#undef DEBUG_TX
#undef DEBUG_IRQ
#undef DEBUG_RX
#undef DEBUG_RXALLOC
#undef DEBUG_REGISTERS
#undef DEBUG_RING
#undef DEBUG_IRQ_TASKLET
#undef DEBUG_TX_ALLOC
#undef DEBUG_TX_DESC

#define CONFIG_RTL8180_IO_MAP

#include "r8180_hw.h"
#include "r8187.h"
#include "r8180_rtl8225.h" /* RTL8225 Radio frontend */
#include "r8180_93cx6.h"   /* Card EEPROM */
#include "r8180_wx.h"

#include <linux/usb.h>
// FIXME: check if 2.6.7 is ok
#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,6,7))
#define usb_kill_urb usb_unlink_urb
#endif

#ifdef CONFIG_RTL8180_PM
#include "r8180_pm.h"
#endif

#ifndef USB_VENDOR_ID_REALTEK
#define USB_VENDOR_ID_REALTEK		0x0bda
#endif
#ifndef USB_VENDOR_ID_NETGEAR
#define USB_VENDOR_ID_NETGEAR		0x0846
#endif

#define TXISR_SELECT(priority)	  ((priority == MANAGE_PRIORITY)?rtl8187_managetx_isr:\
	(priority == BEACON_PRIORITY)?rtl8187_beacontx_isr: \
	(priority == VO_PRIORITY)?rtl8187_votx_isr: \
	(priority == VI_PRIORITY)?rtl8187_vitx_isr:\
	(priority == BE_PRIORITY)?rtl8187_betx_isr:rtl8187_bktx_isr)

 
static struct usb_device_id rtl8187_usb_id_tbl[] = {
	{USB_DEVICE(USB_VENDOR_ID_REALTEK, 0x8187)},
	{USB_DEVICE(USB_VENDOR_ID_REALTEK, 0x8189)},
//	{USB_DEVICE_VER(USB_VENDOR_ID_REALTEK, 0x8187,0x0200,0x0200)},
	{USB_DEVICE(USB_VENDOR_ID_NETGEAR, 0x6100)},
	{USB_DEVICE(USB_VENDOR_ID_NETGEAR, 0x6a00)},
	{}
};

static char* ifname = "wlan%d";
#if 0
static int hwseqnum = 0;
static int hwwep = 0;
#endif
static int channels = 0x3fff;

MODULE_LICENSE("GPL");
#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0))
MODULE_VERSION("V 1.1");
#endif
MODULE_DEVICE_TABLE(usb, rtl8187_usb_id_tbl);
MODULE_AUTHOR("Andrea Merello <andreamrl@tiscali.it>");
MODULE_DESCRIPTION("Linux driver for Realtek RTL8187 WiFi cards");

#if 0
MODULE_PARM(ifname,"s");
MODULE_PARM_DESC(devname," Net interface name, wlan%d=default");

MODULE_PARM(hwseqnum,"i");
MODULE_PARM_DESC(hwseqnum," Try to use hardware 802.11 header sequence numbers. Zero=default");

MODULE_PARM(hwwep,"i");
MODULE_PARM_DESC(hwwep," Try to use hardware WEP support. Still broken and not available on all cards");

MODULE_PARM(channels,"i");
MODULE_PARM_DESC(channels," Channel bitmask for specific locales. NYI");
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 9)
module_param(ifname, charp, S_IRUGO|S_IWUSR );
//module_param(hwseqnum,int, S_IRUGO|S_IWUSR);
//module_param(hwwep,int, S_IRUGO|S_IWUSR);
module_param(channels,int, S_IRUGO|S_IWUSR);
#else
MODULE_PARM(ifname, "s");
//MODULE_PARM(hwseqnum,"i");
//MODULE_PARM(hwwep,"i");
MODULE_PARM(channels,"i");
#endif

MODULE_PARM_DESC(devname," Net interface name, wlan%d=default");
//MODULE_PARM_DESC(hwseqnum," Try to use hardware 802.11 header sequence numbers. Zero=default");
//MODULE_PARM_DESC(hwwep," Try to use hardware WEP support. Still broken and not available on all cards");
MODULE_PARM_DESC(channels," Channel bitmask for specific locales. NYI");

CHANNEL_LIST	DefaultChannelPlan[] = {
	{{1,2,3,4,5,6,7,8,9,10,11,36,40,44,48,52,56,60,64,149,153,157,161,165},24},
	{{1,2,3,4,5,6,7,8,9,10,11},11},
	{{1,2,3,4,5,6,7,8,9,10,11,12,13,36,40,44,48,52,56,60,64},21},
	{{1,2,3,4,5,6,7,8,9,10,11,12,13},13},
	{{1,2,3,4,5,6,7,8,9,10,11,12,13},13},
	{{1,2,3,4,5,6,7,8,9,10,11,12,13,14,36,40,44,48,52,56,60,64},22},
	{{1,2,3,4,5,6,7,8,9,10,11,12,13,14,36,40,44,48,52,56,60,64},22},
	{{1,2,3,4,5,6,7,8,9,10,11,12,13},13},				//sean fix (for cameo)
	{{1,2,3,4,5,6,7,8,9,10,11,12,13,14,36,40,44,48,52,56,60,64},22},};//Ida add for 11a

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
static int __devinit rtl8187_usb_probe(struct usb_interface *intf,
			 const struct usb_device_id *id);
static void __devexit rtl8187_usb_disconnect(struct usb_interface *intf);
#else
static void *__devinit rtl8187_usb_probe(struct usb_device *udev,unsigned int ifnum,
			 const struct usb_device_id *id);
static void __devexit rtl8187_usb_disconnect(struct usb_device *udev, void *ptr);
#endif
		 

static struct usb_driver rtl8187_usb_driver = {
#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 15)
	.owner		= THIS_MODULE,
#endif
	.name		= RTL8187_MODULE_NAME,	          /* Driver name   */
	.id_table	= rtl8187_usb_id_tbl,	          /* PCI_ID table  */
	.probe		= rtl8187_usb_probe,	          /* probe fn      */
	.disconnect	= rtl8187_usb_disconnect,	  /* remove fn     */
#if LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 0)
#ifdef CONFIG_RTL8180_PM
	.suspend	= rtl8180_suspend,	          /* PM suspend fn */
	.resume		= rtl8180_resume,                 /* PM resume fn  */
#else
	.suspend	= NULL,			          /* PM suspend fn */
	.resume      	= NULL,			          /* PM resume fn  */
#endif
#endif
};

void write_nic_byte_E(struct net_device *dev, int indx, u8 data)
{
	int status;	
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct usb_device *udev = priv->udev;
	
	status = usb_control_msg(udev, usb_sndctrlpipe(udev, 0),
			       RTL8187_REQ_SET_REGS, RTL8187_REQT_WRITE,
			       indx|0xfe00, 0, &data, 1, HZ / 2);

	if (status < 0)
	{
		printk("write_nic_byte_E TimeOut! status:%x\n", status);
	}	
}

u8 read_nic_byte_E(struct net_device *dev, int indx)
{
	int status;
	u8 data;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct usb_device *udev = priv->udev;
	
	status = usb_control_msg(udev, usb_rcvctrlpipe(udev, 0),
			       RTL8187_REQ_GET_REGS, RTL8187_REQT_READ,
			       indx|0xfe00, 0, &data, 1, HZ / 2);

        if (status < 0)
        {
                printk("read_nic_byte_E TimeOut! status:%x\n", status);
        }

	return data;
}

void write_nic_byte(struct net_device *dev, int indx, u8 data)
{
	int status;
	
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct usb_device *udev = priv->udev;
	
	status = usb_control_msg(udev, usb_sndctrlpipe(udev, 0),
			       RTL8187_REQ_SET_REGS, RTL8187_REQT_WRITE,
			       (indx&0xff)|0xff00, (indx>>8)&0x03, &data, 1, HZ / 2);

        if (status < 0)
        {
                printk("write_nic_byte TimeOut! status:%x\n", status);
        }


}


void write_nic_word(struct net_device *dev, int indx, u16 data)
{
	
	int status;
	
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct usb_device *udev = priv->udev;
	
	status = usb_control_msg(udev, usb_sndctrlpipe(udev, 0),
			       RTL8187_REQ_SET_REGS, RTL8187_REQT_WRITE,
			       (indx&0xff)|0xff00, (indx>>8)&0x03, &data, 2, HZ / 2);

        if (status < 0)
        {
                printk("write_nic_word TimeOut! status:%x\n", status);
        }

}


void write_nic_dword(struct net_device *dev, int indx, u32 data)
{

	int status;
	
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct usb_device *udev = priv->udev;
	
	status = usb_control_msg(udev, usb_sndctrlpipe(udev, 0),
			       RTL8187_REQ_SET_REGS, RTL8187_REQT_WRITE,
			       (indx&0xff)|0xff00, (indx>>8)&0x03, &data, 4, HZ / 2);


        if (status < 0)
        {
                printk("write_nic_dword TimeOut! status:%x\n", status);
        }

}
 
 
 
u8 read_nic_byte(struct net_device *dev, int indx)
{
	u8 data;
	int status;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct usb_device *udev = priv->udev;
	
	status = usb_control_msg(udev, usb_rcvctrlpipe(udev, 0),
			       RTL8187_REQ_GET_REGS, RTL8187_REQT_READ,
			       (indx&0xff)|0xff00, (indx>>8)&0x03, &data, 1, HZ / 2);
	
        if (status < 0)
        {
                printk("read_nic_byte TimeOut! status:%x\n", status);
        }



	return data;
}


 
u16 read_nic_word(struct net_device *dev, int indx)
{
	u16 data;
	int status;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct usb_device *udev = priv->udev;
	
	status = usb_control_msg(udev, usb_rcvctrlpipe(udev, 0),
			       RTL8187_REQ_GET_REGS, RTL8187_REQT_READ,
			       (indx&0xff)|0xff00, (indx>>8)&0x03, &data, 2, HZ / 2);
	
        if (status < 0)
        {
                printk("read_nic_word TimeOut! status:%x\n", status);
        }


	return data;
}


u32 read_nic_dword(struct net_device *dev, int indx)
{
	u32 data;
	int status;
//	int result;
	
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct usb_device *udev = priv->udev;
	
	status = usb_control_msg(udev, usb_rcvctrlpipe(udev, 0),
			       RTL8187_REQ_GET_REGS, RTL8187_REQT_READ,
			       (indx&0xff)|0xff00, (indx>>8)&0x03, &data, 4, HZ / 2);
//	if(0 != result) {
//	  printk(KERN_WARNING "read size of data = %d\, date = %d\n", result, data);
//	}
	
        if (status < 0)
        {
                printk("read_nic_dword TimeOut! status:%x\n", status);
        }



	return data;
}


u8 read_phy_cck(struct net_device *dev, u8 adr);
u8 read_phy_ofdm(struct net_device *dev, u8 adr);
/* this might still called in what was the PHY rtl8185/rtl8187 common code 
 * plans are to possibilty turn it again in one common code...
 */
inline void force_pci_posting(struct net_device *dev)
{
}


//irqreturn_t rtl8180_interrupt(int irq, void *netdev, struct pt_regs *regs);
//void set_nic_rxring(struct net_device *dev);
//void set_nic_txring(struct net_device *dev);
static struct net_device_stats *rtl8180_stats(struct net_device *dev);
void rtl8180_commit(struct net_device *dev);
//void rtl8180_restart(struct net_device *dev);
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,20))
void rtl8180_restart(struct work_struct *work);
//void rtl8180_rq_tx_ack(struct work_struct *work);
#else
 void rtl8180_restart(struct net_device *dev);
//void rtl8180_rq_tx_ack(struct net_device *dev);
#endif
/****************************************************************************
   -----------------------------PROCFS STUFF-------------------------
*****************************************************************************/

static struct proc_dir_entry *rtl8180_proc = NULL;

static int proc_get_registers(char *page, char **start,
			  off_t offset, int count,
			  int *eof, void *data)
{
	struct net_device *dev = data;
//	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	
	int len = 0;
	int i,n;
			
	int max=0xff;
	
	/* This dump the current register page */
	for(n=0;n<=max;)
	{
		//printk( "\nD: %2x> ", n);
		len += snprintf(page + len, count - len,
			"\nD:  %2x > ",n);

		for(i=0;i<16 && n<=max;i++,n++)
		len += snprintf(page + len, count - len,
			"%2x ",read_nic_byte(dev,n));

		//	printk("%2x ",read_nic_byte(dev,n));
	}
	len += snprintf(page + len, count - len,"\n");


		
	*eof = 1;
	return len;

}


static int proc_get_cck_reg(char *page, char **start,
			  off_t offset, int count,
			  int *eof, void *data)
{
	struct net_device *dev = data;
//	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	
	int len = 0;
	int i,n;
			
	int max = 0x5F;
	
	/* This dump the current register page */
	for(n=0;n<=max;)
	{
		//printk( "\nD: %2x> ", n);
		len += snprintf(page + len, count - len,
			"\nD:  %2x > ",n);

		for(i=0;i<16 && n<=max;i++,n++)
		len += snprintf(page + len, count - len,
			"%2x ",read_phy_cck(dev,n));

		//	printk("%2x ",read_nic_byte(dev,n));
	}
	len += snprintf(page + len, count - len,"\n");

		
	*eof = 1;
	return len;

}


static int proc_get_ofdm_reg(char *page, char **start,
			  off_t offset, int count,
			  int *eof, void *data)
{
	struct net_device *dev = data;
//	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	
	int len = 0;
	int i,n;
			
	//int max=0xff;
	int max = 0x40;
	
	/* This dump the current register page */
	for(n=0;n<=max;)
	{
		//printk( "\nD: %2x> ", n);
		len += snprintf(page + len, count - len,
			"\nD:  %2x > ",n);

		for(i=0;i<16 && n<=max;i++,n++)
		len += snprintf(page + len, count - len,
			"%2x ",read_phy_ofdm(dev,n));

		//	printk("%2x ",read_nic_byte(dev,n));
	}
	len += snprintf(page + len, count - len,"\n");


		
	*eof = 1;
	return len;

}


#if 0
static int proc_get_stats_hw(char *page, char **start,
			  off_t offset, int count,
			  int *eof, void *data)
{
	struct net_device *dev = data;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	
	int len = 0;
	
	len += snprintf(page + len, count - len,
		"NIC int: %lu\n"
		"Total int: %lu\n",
		priv->stats.ints,
		priv->stats.shints);
			
	*eof = 1;
	return len;
}
#endif

static int proc_get_stats_tx(char *page, char **start,
			  off_t offset, int count,
			  int *eof, void *data)
{
	struct net_device *dev = data;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	
	int len = 0;
	
	len += snprintf(page + len, count - len,
		"TX VI priority ok int: %lu\n"
		"TX VI priority error int: %lu\n"
		"TX VO priority ok int: %lu\n"
		"TX VO priority error int: %lu\n"
		"TX BE priority ok int: %lu\n"
		"TX BE priority error int: %lu\n"
		"TX BK priority ok int: %lu\n"
		"TX BK priority error int: %lu\n"
		"TX MANAGE priority ok int: %lu\n"
		"TX MANAGE priority error int: %lu\n"
		"TX BEACON priority ok int: %lu\n"
		"TX BEACON priority error int: %lu\n"
//		"TX high priority ok int: %lu\n"
//		"TX high priority failed error int: %lu\n"
		"TX queue resume: %lu\n"
		"TX queue stopped?: %d\n"
		"TX fifo overflow: %lu\n"
//		"TX beacon: %lu\n"
		"TX VI queue: %d\n"
		"TX VO queue: %d\n"
		"TX BE queue: %d\n"
		"TX BK queue: %d\n"
//		"TX HW queue: %d\n"
		"TX VI dropped: %lu\n"
		"TX VO dropped: %lu\n"
		"TX BE dropped: %lu\n"
		"TX BK dropped: %lu\n"
		"TX total data packets %lu\n",		
//		"TX beacon aborted: %lu\n",
		priv->stats.txviokint,
		priv->stats.txvierr,
		priv->stats.txvookint,
		priv->stats.txvoerr,
		priv->stats.txbeokint,
		priv->stats.txbeerr,
		priv->stats.txbkokint,
		priv->stats.txbkerr,
		priv->stats.txmanageokint,
		priv->stats.txmanageerr,
		priv->stats.txbeaconokint,
		priv->stats.txbeaconerr,
//		priv->stats.txhpokint,
//		priv->stats.txhperr,
		priv->stats.txresumed,
		netif_queue_stopped(dev),
		priv->stats.txoverflow,
//		priv->stats.txbeacon,
		atomic_read(&(priv->tx_pending[VI_PRIORITY])),
		atomic_read(&(priv->tx_pending[VO_PRIORITY])),
		atomic_read(&(priv->tx_pending[BE_PRIORITY])),
		atomic_read(&(priv->tx_pending[BK_PRIORITY])),
//		read_nic_byte(dev, TXFIFOCOUNT),
		priv->stats.txvidrop,
		priv->stats.txvodrop,
		priv->stats.txbedrop,
		priv->stats.txbkdrop,
		priv->stats.txdatapkt
//		priv->stats.txbeaconerr
		);
			
	*eof = 1;
	return len;
}		



static int proc_get_stats_rx(char *page, char **start,
			  off_t offset, int count,
			  int *eof, void *data)
{
	struct net_device *dev = data;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	
	int len = 0;
	
	len += snprintf(page + len, count - len,
		"RX packets: %lu\n"
		"RX urb status error: %lu\n"
		"RX invalid urb error: %lu\n",
		priv->stats.rxok,
		priv->stats.rxstaterr,
		priv->stats.rxurberr);
			
	*eof = 1;
	return len;
}		

#if WIRELESS_EXT < 17
static struct iw_statistics *r8180_get_wireless_stats(struct net_device *dev)
{
       struct r8180_priv *priv = ieee80211_priv(dev);

       return &priv->wstats;
}
#endif

void rtl8180_proc_module_init(void)
{	
	DMESG("Initializing proc filesystem");
	rtl8180_proc=create_proc_entry(RTL8187_MODULE_NAME, S_IFDIR, proc_net);
}


void rtl8180_proc_module_remove(void)
{
	remove_proc_entry(RTL8187_MODULE_NAME, proc_net);
}


void rtl8180_proc_remove_one(struct net_device *dev)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	if (priv->dir_dev) {
	//	remove_proc_entry("stats-hw", priv->dir_dev);
		remove_proc_entry("stats-tx", priv->dir_dev);
		remove_proc_entry("stats-rx", priv->dir_dev);
	//	remove_proc_entry("stats-ieee", priv->dir_dev);
	//	remove_proc_entry("stats-ap", priv->dir_dev);
		remove_proc_entry("registers", priv->dir_dev);
		remove_proc_entry("cck-registers",priv->dir_dev);
		remove_proc_entry("ofdm-registers",priv->dir_dev);
		remove_proc_entry(dev->name, rtl8180_proc);
		priv->dir_dev = NULL;
	}
}


void rtl8180_proc_init_one(struct net_device *dev)
{
	struct proc_dir_entry *e;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	priv->dir_dev = create_proc_entry(dev->name, 
					  S_IFDIR | S_IRUGO | S_IXUGO, 
					  rtl8180_proc);
	if (!priv->dir_dev) {
		DMESGE("Unable to initialize /proc/net/rtl8187/%s\n",
		      dev->name);
		return;
	}
	#if 0
	e = create_proc_read_entry("stats-hw", S_IFREG | S_IRUGO,
				   priv->dir_dev, proc_get_stats_hw, dev);
				   
	if (!e) {
		DMESGE("Unable to initialize "
		      "/proc/net/rtl8187/%s/stats-hw\n",
		      dev->name);
	}
	#endif
	e = create_proc_read_entry("stats-rx", S_IFREG | S_IRUGO,
				   priv->dir_dev, proc_get_stats_rx, dev);
				   
	if (!e) {
		DMESGE("Unable to initialize "
		      "/proc/net/rtl8187/%s/stats-rx\n",
		      dev->name);
	}
	
	
	e = create_proc_read_entry("stats-tx", S_IFREG | S_IRUGO,
				   priv->dir_dev, proc_get_stats_tx, dev);
				   
	if (!e) {
		DMESGE("Unable to initialize "
		      "/proc/net/rtl8187/%s/stats-tx\n",
		      dev->name);
	}
	#if 0
	e = create_proc_read_entry("stats-ieee", S_IFREG | S_IRUGO,
				   priv->dir_dev, proc_get_stats_ieee, dev);
				   
	if (!e) {
		DMESGE("Unable to initialize "
		      "/proc/net/rtl8187/%s/stats-ieee\n",
		      dev->name);
	}
	
	
	e = create_proc_read_entry("stats-ap", S_IFREG | S_IRUGO,
				   priv->dir_dev, proc_get_stats_ap, dev);
				   
	if (!e) {
		DMESGE("Unable to initialize "
		      "/proc/net/rtl8187/%s/stats-ap\n",
		      dev->name);
	}
	#endif
	
	e = create_proc_read_entry("registers", S_IFREG | S_IRUGO,
				   priv->dir_dev, proc_get_registers, dev);
	if (!e) {
		DMESGE("Unable to initialize "
		      "/proc/net/rtl8187/%s/registers\n",
		      dev->name);
	}

	e = create_proc_read_entry("cck-registers", S_IFREG | S_IRUGO,
				   priv->dir_dev, proc_get_cck_reg, dev);
	if (!e) {
		DMESGE("Unable to initialize "
		      "/proc/net/rtl8187/%s/cck-registers\n",
		      dev->name);
	}
	
	e = create_proc_read_entry("ofdm-registers", S_IFREG | S_IRUGO,
				   priv->dir_dev, proc_get_ofdm_reg, dev);
	if (!e) {
		DMESGE("Unable to initialize "
		      "/proc/net/rtl8187/%s/ofdm-registers\n",
		      dev->name);
	}

}
/****************************************************************************
   -----------------------------MISC STUFF-------------------------
*****************************************************************************/

/* this is only for debugging */
void print_buffer(u32 *buffer, int len)
{
	int i;
	u8 *buf =(u8*)buffer;
	
	printk("ASCII BUFFER DUMP (len: %x):\n",len);
	
	for(i=0;i<len;i++)
		printk("%c",buf[i]);
		
	printk("\nBINARY BUFFER DUMP (len: %x):\n",len);
	
	for(i=0;i<len;i++)
		printk("%x",buf[i]);

	printk("\n");
}

short check_nic_enought_desc(struct net_device *dev, priority_t priority)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	//int used = atomic_read((priority == NORM_PRIORITY) ? 
	//	&priv->tx_np_pending : &priv->tx_lp_pending);
	int used = atomic_read(&priv->tx_pending[priority]); 
	
	return (used < MAX_TX_URB);
}

void tx_timeout(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	//rtl8180_commit(dev);

#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0))
	schedule_work(&priv->reset_wq);
#else
	schedule_task(&priv->reset_wq);
#endif
	//DMESG("TXTIMEOUT");
}


/* this is only for debug */
void dump_eprom(struct net_device *dev)
{
	int i;
	for(i=0; i<63; i++)
		DMESG("EEPROM addr %x : %x", i, eprom_read(dev,i));
}

/* this is only for debug */
void rtl8180_dump_reg(struct net_device *dev)
{
	int i;
	int n;
	int max=0xff;
	
	DMESG("Dumping NIC register map");	
	
	for(n=0;n<=max;)
	{
		printk( "\nD: %2x> ", n);
		for(i=0;i<16 && n<=max;i++,n++)
			printk("%2x ",read_nic_byte(dev,n));
	}
	printk("\n");
}

/****************************************************************************
      ------------------------------HW STUFF---------------------------
*****************************************************************************/


void rtl8180_irq_enable(struct net_device *dev)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);	
	//priv->irq_enabled = 1;
/*
	write_nic_word(dev,INTA_MASK,INTA_RXOK | INTA_RXDESCERR | INTA_RXOVERFLOW |\ 
	INTA_TXOVERFLOW | INTA_HIPRIORITYDESCERR | INTA_HIPRIORITYDESCOK |\ 
	INTA_NORMPRIORITYDESCERR | INTA_NORMPRIORITYDESCOK |\
	INTA_LOWPRIORITYDESCERR | INTA_LOWPRIORITYDESCOK | INTA_TIMEOUT);
*/
	write_nic_word(dev,INTA_MASK, priv->irq_mask);
}


void rtl8180_irq_disable(struct net_device *dev)
{
//	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);	

	write_nic_word(dev,INTA_MASK,0);
	force_pci_posting(dev);
//	priv->irq_enabled = 0;
}


void rtl8180_set_mode(struct net_device *dev,int mode)
{
	u8 ecmd;
	ecmd=read_nic_byte(dev, EPROM_CMD);
	ecmd=ecmd &~ EPROM_CMD_OPERATING_MODE_MASK;
	ecmd=ecmd | (mode<<EPROM_CMD_OPERATING_MODE_SHIFT);
	ecmd=ecmd &~ (1<<EPROM_CS_SHIFT);
	ecmd=ecmd &~ (1<<EPROM_CK_SHIFT);
	write_nic_byte(dev, EPROM_CMD, ecmd);
}


void rtl8180_update_msr(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	u8 msr;
	
	msr  = read_nic_byte(dev, MSR);
	msr &= ~ MSR_LINK_MASK;
	
	/* do not change in link_state != WLAN_LINK_ASSOCIATED.
	 * msr must be updated if the state is ASSOCIATING. 
	 * this is intentional and make sense for ad-hoc and
	 * master (see the create BSS/IBSS func)
	 */
	if (priv->ieee80211->state == IEEE80211_LINKED){ 
			
		if (priv->ieee80211->iw_mode == IW_MODE_INFRA)
			msr |= (MSR_LINK_MANAGED<<MSR_LINK_SHIFT);
		else if (priv->ieee80211->iw_mode == IW_MODE_ADHOC)
			msr |= (MSR_LINK_ADHOC<<MSR_LINK_SHIFT);
		else if (priv->ieee80211->iw_mode == IW_MODE_MASTER)
			msr |= (MSR_LINK_MASTER<<MSR_LINK_SHIFT);
		
	}else
		msr |= (MSR_LINK_NONE<<MSR_LINK_SHIFT);
		
	write_nic_byte(dev, MSR, msr);
}

void rtl8180_set_chan(struct net_device *dev,short ch)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	u32 tx;

	priv->chan=ch;
	#if 0
	if(priv->ieee80211->iw_mode == IW_MODE_ADHOC || 
		priv->ieee80211->iw_mode == IW_MODE_MASTER){
	
			priv->ieee80211->link_state = WLAN_LINK_ASSOCIATED;	
			priv->ieee80211->master_chan = ch;
			rtl8180_update_beacon_ch(dev); 
		}
	#endif
	
	/* this hack should avoid frame TX during channel setting*/
	tx = read_nic_dword(dev,TX_CONF);
	tx &= ~TX_LOOPBACK_MASK;

#ifndef LOOP_TEST	
	write_nic_dword(dev,TX_CONF, tx |( TX_LOOPBACK_MAC<<TX_LOOPBACK_SHIFT));

	priv->rf_set_chan(dev,priv->chan);
	mdelay(10);
	write_nic_dword(dev,TX_CONF,tx | (TX_LOOPBACK_NONE<<TX_LOOPBACK_SHIFT));
#endif
}
void rtl8187_rx_isr(struct urb *rx_urb, struct pt_regs *regs);
void rtl8187_rx_manage_isr(struct urb *rx_urb, struct pt_regs *regs);


void rtl8187_rx_urbsubmit(struct net_device *dev, struct urb* rx_urb)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	int err;
	
//	u8 *rx;
	
	//DMESG("starting RX");
	/*rx = kmalloc(RX_URB_SIZE*sizeof(u8),GFP_ATOMIC);
	if(!rx){ 
		DMESGE("unable to allocate RX buffer");
		return;
	}*/
	
	usb_fill_bulk_urb(rx_urb,priv->udev,
		usb_rcvbulkpipe(priv->udev,(NIC_8187 == priv->card_8187)?0x81:0x83), 
                rx_urb->transfer_buffer,
                RX_URB_SIZE,
                rtl8187_rx_isr,
                dev);
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
	err = usb_submit_urb(rx_urb, GFP_ATOMIC);	
#else
	err = usb_submit_urb(rx_urb);	
#endif
	if(err && err != -EPERM){
		DMESGE("cannot submit RX command. URB_STATUS %x",rx_urb->status);
	}
}


void rtl8187_rx_manage_urbsubmit(struct net_device *dev, struct urb* rx_urb)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	int err;
#ifdef THOMAS_BEACON
	usb_fill_bulk_urb(rx_urb,priv->udev,
		usb_rcvbulkpipe(priv->udev,0x09), rx_urb->transfer_buffer,
			rx_urb->transfer_buffer_length,
			rtl8187_rx_manage_isr, dev);
#else
	usb_fill_bulk_urb(rx_urb,priv->udev,
		usb_rcvbulkpipe(priv->udev,0x09), rx_urb->transfer_buffer,
			RX_URB_SIZE, rtl8187_rx_manage_isr,dev);

#endif

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
	err = usb_submit_urb(rx_urb, GFP_ATOMIC);	
#else
	err = usb_submit_urb(rx_urb);	
#endif
	if(err && err != -EPERM){
		DMESGE("cannot submit RX command. URB_STATUS %x",rx_urb->status);
	}
}


#ifndef JACKSON_NEW_RX
void rtl8187_rx_initiate(struct net_device *dev)
{
	int i;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	
	if(!priv->rx_urb)
		DMESGE("Cannot intiate RX urb mechanism");
	for(i=0;i<MAX_RX_URB;i++) // RX_MAX_URB is 1 
		rtl8187_rx_urbsubmit(dev,priv->rx_urb[i]);
		
}
#else
void rtl8187_rx_initiate(struct net_device *dev)
{
        int i;

        struct urb *purb;

        struct sk_buff *pskb;

        struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);

        priv->tx_urb_index = 0;

        if ((!priv->rx_urb) || (!priv->pp_rxskb)) {

                DMESGE("Cannot intiate RX urb mechanism");
                return;

        }

        priv->rx_inx = 0;
#ifdef THOMAS_TASKLET
	atomic_set(&priv->irt_counter,0);
#endif
        for(i = 0;i < MAX_RX_URB; i++){

                purb = priv->rx_urb[i] = usb_alloc_urb(0,GFP_KERNEL);

                if(!priv->rx_urb[i])
                        goto destroy;

                pskb = priv->pp_rxskb[i] =  dev_alloc_skb (RX_URB_SIZE);

                if (pskb == NULL)
                        goto destroy;

                purb->transfer_buffer_length = RX_URB_SIZE;
                purb->transfer_buffer = pskb->data;
        }


        for(i=0;i<MAX_RX_URB;i++)
                rtl8187_rx_urbsubmit(dev,priv->rx_urb[i]);

        return;

destroy:

        for(i = 0; i < MAX_RX_URB; i++) {

                purb = priv->rx_urb[i];

                if (purb)
                        usb_free_urb(purb);

                pskb = priv->pp_rxskb[i];

                if (pskb)
                        dev_kfree_skb_any(pskb);

        }

        return;
}
#endif


void rtl8187_rx_manage_initiate(struct net_device *dev)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	if(!priv->rx_urb)
		DMESGE("Cannot intiate RX urb mechanism");

	rtl8187_rx_manage_urbsubmit(dev,priv->rx_urb[MAX_RX_URB]);
		
}


void rtl8187_set_rxconf(struct net_device *dev)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	u32 rxconf;
	
	rxconf=read_nic_dword(dev,RX_CONF);
	rxconf = rxconf &~ MAC_FILTER_MASK;
	rxconf = rxconf | (1<<ACCEPT_MNG_FRAME_SHIFT);
	rxconf = rxconf | (1<<ACCEPT_DATA_FRAME_SHIFT);
	rxconf = rxconf | (1<<ACCEPT_BCAST_FRAME_SHIFT);
	rxconf = rxconf | (1<<ACCEPT_MCAST_FRAME_SHIFT);
	//rxconf = rxconf | (1<<ACCEPT_CTL_FRAME_SHIFT);	

	if (dev->flags & IFF_PROMISC) DMESG ("NIC in promisc mode");
	
	if(priv->ieee80211->iw_mode == IW_MODE_MONITOR || \
	   dev->flags & IFF_PROMISC){
		rxconf = rxconf | (1<<ACCEPT_ALLMAC_FRAME_SHIFT);
	} /*else if(priv->ieee80211->iw_mode == IW_MODE_MASTER){
		rxconf = rxconf | (1<<ACCEPT_ALLMAC_FRAME_SHIFT);
		rxconf = rxconf | (1<<RX_CHECK_BSSID_SHIFT);
	}*/else{
		rxconf = rxconf | (1<<ACCEPT_NICMAC_FRAME_SHIFT);
		rxconf = rxconf | (1<<RX_CHECK_BSSID_SHIFT);
	}
	
	
	if(priv->ieee80211->iw_mode == IW_MODE_MONITOR){
		rxconf = rxconf | (1<<ACCEPT_ICVERR_FRAME_SHIFT);
		rxconf = rxconf | (1<<ACCEPT_PWR_FRAME_SHIFT);
	}
	
	if( priv->crcmon == 1 && priv->ieee80211->iw_mode == IW_MODE_MONITOR)
		rxconf = rxconf | (1<<ACCEPT_CRCERR_FRAME_SHIFT);
	
	
	rxconf = rxconf &~ RX_FIFO_THRESHOLD_MASK;
	rxconf = rxconf | (RX_FIFO_THRESHOLD_NONE<<RX_FIFO_THRESHOLD_SHIFT);
	rxconf = rxconf &~ MAX_RX_DMA_MASK;
	rxconf = rxconf | (MAX_RX_DMA_2048<<MAX_RX_DMA_SHIFT);

	rxconf = rxconf | (1<<RX_AUTORESETPHY_SHIFT);
	rxconf = rxconf | RCR_ONLYERLPKT;
	
//	rxconf = rxconf &~ RCR_CS_MASK;
//	rxconf = rxconf | (1<<RCR_CS_SHIFT);

	write_nic_dword(dev, RX_CONF, rxconf);	
	
	#ifdef DEBUG_RX
	DMESG("rxconf: %x %x",rxconf ,read_nic_dword(dev,RX_CONF));
	#endif
}

void rtl8180_rx_enable(struct net_device *dev)
{
	u8 cmd;

	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);

	rtl8187_rx_initiate(dev);
	rtl8187_set_rxconf(dev);	

	if(NIC_8187 == priv->card_8187) {
		cmd=read_nic_byte(dev,CMD);
		write_nic_byte(dev,CMD,cmd | (1<<CMD_RX_ENABLE_SHIFT));
	}
	else {
		//write_nic_dword(dev, RCR, priv->ReceiveConfig);
	}
}


void rtl8180_tx_enable(struct net_device *dev)
{
	u8 cmd;
	u8 byte;
	u32 txconf;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	//test loopback
	//	priv->TransmitConfig |= (TX_LOOPBACK_BASEBAND<<TX_LOOPBACK_SHIFT);
	if(NIC_8187B == priv->card_8187){
		write_nic_dword(dev, TCR, priv->TransmitConfig);	
		byte = read_nic_byte(dev, MSR);
		byte |= MSR_LINK_ENEDCA;
		write_nic_byte(dev, MSR, byte);
	} else {
		byte = read_nic_byte(dev,CW_CONF);
		byte &= ~(1<<CW_CONF_PERPACKET_CW_SHIFT);
		byte &= ~(1<<CW_CONF_PERPACKET_RETRY_SHIFT);
		write_nic_byte(dev, CW_CONF, byte);

		byte = read_nic_byte(dev, TX_AGC_CTL);
		byte &= ~(1<<TX_AGC_CTL_PERPACKET_GAIN_SHIFT);
		byte &= ~(1<<TX_AGC_CTL_PERPACKET_ANTSEL_SHIFT);
		byte &= ~(1<<TX_AGC_CTL_FEEDBACK_ANT);
		write_nic_byte(dev, TX_AGC_CTL, byte);

		txconf= read_nic_dword(dev,TX_CONF);


		txconf = txconf &~ TX_LOOPBACK_MASK;

#ifndef LOOP_TEST
		txconf = txconf | (TX_LOOPBACK_NONE<<TX_LOOPBACK_SHIFT);
#else
		txconf = txconf | (TX_LOOPBACK_BASEBAND<<TX_LOOPBACK_SHIFT);
#endif
		txconf = txconf &~ TCR_SRL_MASK;
		txconf = txconf &~ TCR_LRL_MASK;

		txconf = txconf | (priv->retry_data<<TX_LRLRETRY_SHIFT); // long
		txconf = txconf | (priv->retry_rts<<TX_SRLRETRY_SHIFT); // short

		txconf = txconf &~ (1<<TX_NOCRC_SHIFT);

		txconf = txconf &~ TCR_MXDMA_MASK;
		txconf = txconf | (TCR_MXDMA_2048<<TCR_MXDMA_SHIFT);

		txconf = txconf | TCR_DISReqQsize;
		txconf = txconf | TCR_DISCW;
		txconf = txconf &~ TCR_SWPLCPLEN;

		txconf=txconf | (1<<TX_NOICV_SHIFT);

		write_nic_dword(dev,TX_CONF,txconf);

#ifdef DEBUG_TX
		DMESG("txconf: %x %x",txconf,read_nic_dword(dev,TX_CONF));
#endif

		cmd=read_nic_byte(dev,CMD);
		write_nic_byte(dev,CMD,cmd | (1<<CMD_TX_ENABLE_SHIFT));		
	}
}

#if 0
void rtl8180_beacon_tx_enable(struct net_device *dev)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	priv->dma_poll_mask &=~(1<<TX_DMA_STOP_BEACON_SHIFT);
	rtl8180_set_mode(dev,EPROM_CMD_CONFIG);
	write_nic_byte(dev,TX_DMA_POLLING,priv->dma_poll_mask);	
	rtl8180_set_mode(dev,EPROM_CMD_NORMAL);
}


void rtl8180_
_disable(struct net_device *dev) 
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	priv->dma_poll_mask |= (1<<TX_DMA_STOP_BEACON_SHIFT);
	rtl8180_set_mode(dev,EPROM_CMD_CONFIG);
	write_nic_byte(dev,TX_DMA_POLLING,priv->dma_poll_mask);
	rtl8180_set_mode(dev,EPROM_CMD_NORMAL);
}

#endif


void rtl8180_rtx_disable(struct net_device *dev)
{
	u8 cmd;
	int i;
	struct r8180_priv *priv = ieee80211_priv(dev);
	
	cmd=read_nic_byte(dev,CMD);
	write_nic_byte(dev, CMD, cmd &~ \
		       ((1<<CMD_RX_ENABLE_SHIFT)|(1<<CMD_TX_ENABLE_SHIFT)));
	force_pci_posting(dev);
	mdelay(10);


#ifndef JACKSON_NEW_RX

        if(priv->rx_urb){
                for(i=0;i<MAX_RX_URB+1;i++)
                usb_kill_urb(priv->rx_urb[i]);
        }
#endif


	/*while (read_nic_byte(dev,CMD) & (1<<CMD_RX_ENABLE_SHIFT))
	  udelay(10); 
	*/
	
//	if(!priv->rx_skb_complete)
//		dev_kfree_skb_any(priv->rx_skb);


#ifdef THOMAS_BEACON
        if( in_interrupt() )
		printk(KERN_ALERT " %d in interrupt \n",in_interrupt() );
	if(priv->rx_urb){
               for(i=0;i<(MAX_RX_URB+1);i++) {
                   if (priv->rx_urb[i]) {
                                usb_kill_urb(priv->rx_urb[i]);
                                //usb_free_urb(priv->rx_urb[i]);
                        }
                }
        }
#else
#ifdef JACKSON_NEW_RX
        if(priv->rx_urb){
               for(i=0;i<(MAX_RX_URB+1);i++) {
                   if (priv->rx_urb[i]) {
                                usb_kill_urb(priv->rx_urb[i]);
                                usb_free_urb(priv->rx_urb[i]);
                        }
                }
        }
#endif
#endif
}


int alloc_tx_beacon_desc_ring(struct net_device *dev, int count)
{
	#if 0
	int i;
	u32 *tmp;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	
	priv->txbeaconring = (u32*)pci_alloc_consistent(priv->pdev,
					  sizeof(u32)*8*count, 
					  &priv->txbeaconringdma);
	if (!priv->txbeaconring) return -1;
	for (tmp=priv->txbeaconring,i=0;i<count;i++){
		*tmp = *tmp &~ (1<<31); // descriptor empty, owned by the drv 
		/*
		*(tmp+2) = (u32)dma_tmp;
		*(tmp+3) = bufsize;
		*/
		if(i+1<count)
			*(tmp+4) = (u32)priv->txbeaconringdma+((i+1)*8*4);
		else
			*(tmp+4) = (u32)priv->txbeaconringdma;
		
		tmp=tmp+8;
	}
	#endif
	return 0;
}


void rtl8180_reset(struct net_device *dev)
{
	
	struct r8180_priv *priv = ieee80211_priv(dev);
	u8 cr;


	/* make sure the analog power is on before
	 * reset, otherwise reset may fail
	 */
	if(NIC_8187 == priv->card_8187) {
		rtl8180_set_anaparam(dev, RTL8225_ANAPARAM_ON);
		rtl8185_set_anaparam2(dev, RTL8225_ANAPARAM2_ON);
		rtl8180_irq_disable(dev);
		mdelay(200);
		write_nic_byte_E(dev,0x18,0x10);
		write_nic_byte_E(dev,0x18,0x11);
		write_nic_byte_E(dev,0x18,0x00);
		mdelay(200);
	}

	
	cr=read_nic_byte(dev,CMD);
	cr = cr & 2;
	cr = cr | (1<<CMD_RST_SHIFT);
	write_nic_byte(dev,CMD,cr);
	
	force_pci_posting(dev);
	
	mdelay(200);
	
	if(read_nic_byte(dev,CMD) & (1<<CMD_RST_SHIFT)) 
		DMESGW("Card reset timeout!");
	else 
		DMESG("Card successfully reset");
	
	if(NIC_8187 == priv->card_8187) {

		printk("This is RTL8187 Reset procedure\n");
		rtl8180_set_mode(dev,EPROM_CMD_LOAD);
		force_pci_posting(dev);
		mdelay(200);

		/* after the eeprom load cycle, make sure we have
		 * correct anaparams
		 */
		rtl8180_set_anaparam(dev, RTL8225_ANAPARAM_ON);
		rtl8185_set_anaparam2(dev, RTL8225_ANAPARAM2_ON);
	}
	else
		printk("This is RTL8187B Reset procedure\n");

}

inline u16 ieeerate2rtlrate(int rate)
{
	switch(rate){
	case 10:	
	return 0;
	case 20:
	return 1;
	case 55:
	return 2;
	case 110:
	return 3;
	case 60:
	return 4;
	case 90:
	return 5;
	case 120:
	return 6;
	case 180:
	return 7;
	case 240:
	return 8;
	case 360:
	return 9;
	case 480:
	return 10;
	case 540:
	return 11;
	default:
	return 3;
	
	}
}
static u16 rtl_rate[] = {10,20,55,110,60,90,120,180,240,360,480,540};
inline u16 rtl8180_rate2rate(short rate)
{
	if (rate >11) return 0;
	return rtl_rate[rate]; 
}
		
void rtl8180_irq_rx_tasklet(struct r8180_priv *priv);

void rtl8187_rx_isr(struct urb *rx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)rx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);
	priv->rxurb_task = rx_urb;
	
	
//	DMESGW("David: Rx tasklet start!");
#ifndef JACKSON_NEW_RX
	tasklet_schedule(&priv->irq_rx_tasklet);
#else

#ifdef THOMAS_TASKLET
	atomic_inc( &priv->irt_counter );	
	tasklet_schedule(&priv->irq_rx_tasklet);
#else
	rtl8180_irq_rx_tasklet(priv);
#endif

#endif
//	DMESGW("=David: Rx tasklet finish!");
}

void rtl8187_rx_manage_isr(struct urb *rx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)rx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);
	int status,cmd;
	struct sk_buff *skb;
	u32 *desc;
	int ret;


	//DMESG("rtl8187_rx_manage_isr");
	//DMESG("RX %d ",rx_urb->status);
	status = rx_urb->status;
	if(status == 0){
		
		desc = (u32*)(rx_urb->transfer_buffer);
		cmd = (desc[0] >> 30) & 0x03;
//	printk(KERN_ALERT "buffersize = %d, length = %d, pipe = %p\n", rx_urb->transfer_buffer_length, rx_urb->actual_length, rx_urb->pipe>>15);				
		if(cmd == 0x00) {//beacon interrupt
			//send beacon packet
			skb = ieee80211_get_beacon(priv->ieee80211);

			if(!skb){ 
				DMESG("not enought memory for allocating beacon");
				return;
			}
			//printk(KERN_WARNING "to send beacon packet through beacon endpoint!\n");
			ret = rtl8180_tx(dev, (u32*)skb->data, skb->len, BEACON_PRIORITY,
					0, ieeerate2rtlrate(priv->ieee80211->basic_rate));
			
			if( ret != 0 ){
				printk(KERN_ALERT "tx beacon packet error : %d !\n", ret);
			}	
			dev_kfree_skb_any(skb);
		} else {//0x00
			//{ log the device information
			// At present, It is not implemented just now.
			//}
		}

	}else{
		priv->stats.rxstaterr++;
		priv->ieee80211->stats.rx_errors++;
	}

	if(status != -ENOENT)
		rtl8187_rx_manage_urbsubmit(dev, rx_urb);
	else 
		DMESG("Mangement RX process aborted due to explicit shutdown");
}

#if 0
void rtl8180_tx_queues_stop(struct net_device *dev)
{
	//struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	u8 dma_poll_mask = (1<<TX_DMA_STOP_LOWPRIORITY_SHIFT);
	dma_poll_mask |= (1<<TX_DMA_STOP_HIPRIORITY_SHIFT);
	dma_poll_mask |= (1<<TX_DMA_STOP_NORMPRIORITY_SHIFT);
	dma_poll_mask |= (1<<TX_DMA_STOP_BEACON_SHIFT);

	rtl8180_set_mode(dev,EPROM_CMD_CONFIG);
	write_nic_byte(dev,TX_DMA_POLLING,dma_poll_mask);
	rtl8180_set_mode(dev,EPROM_CMD_NORMAL);
}
#endif

void rtl8180_data_hard_stop(struct net_device *dev)
{
	//FIXME !!
	#if 0
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	priv->dma_poll_mask |= (1<<TX_DMA_STOP_LOWPRIORITY_SHIFT);
	rtl8180_set_mode(dev,EPROM_CMD_CONFIG);
	write_nic_byte(dev,TX_DMA_POLLING,priv->dma_poll_mask);
	rtl8180_set_mode(dev,EPROM_CMD_NORMAL);
	#endif
}


void rtl8180_data_hard_resume(struct net_device *dev)
{
	// FIXME !!
	#if 0
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	priv->dma_poll_mask &= ~(1<<TX_DMA_STOP_LOWPRIORITY_SHIFT);
	rtl8180_set_mode(dev,EPROM_CMD_CONFIG);
	write_nic_byte(dev,TX_DMA_POLLING,priv->dma_poll_mask);
	rtl8180_set_mode(dev,EPROM_CMD_NORMAL);
	#endif
}

unsigned int PRI2EP[4] = {0x06,0x07,0x05,0x04};
/* this function TX data frames when the ieee80211 stack requires this.
 * It checks also if we need to stop the ieee tx queue, eventually do it
 */
void rtl8180_hard_data_xmit(struct sk_buff *skb, struct net_device *dev, int rate)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	
	short morefrag = 0;	
	unsigned long flags;
	struct ieee80211_hdr *h = (struct ieee80211_hdr  *) skb->data;

	unsigned char ep;

	if (le16_to_cpu(h->frame_ctl) & IEEE80211_FCTL_MOREFRAGS)
		morefrag = 1;
//	DMESG("%x %x", h->frame_ctl, h->seq_ctl);
	/*
	* This function doesn't require lock because we make
	* sure it's called with the tx_lock already acquired.
	* this come from the kernel's hard_xmit callback (trought
	* the ieee stack, or from the try_wake_queue (again trought
	* the ieee stack.
	*/
	spin_lock_irqsave(&priv->tx_lock,flags);	
		
	//DMESG("TX");
	if(NIC_8187B == priv->card_8187){
		ep = PRI2EP[skb->priority];
	} else {
		ep = LOW_PRIORITY;
	}
	//if (!check_nic_enought_desc(dev, PRI2EP[skb->priority])){
	if (!check_nic_enought_desc(dev, ep)){
		DMESG("Error: no TX slot ");
		ieee80211_stop_queue(priv->ieee80211);
	}
	
	//printk(KERN_WARNING "data rate = %d\n",rate);
	//rtl8180_tx(dev, (u32*)skb->data, skb->len, PRI2EP[skb->priority], morefrag,
	rtl8180_tx(dev, (u32*)skb->data, skb->len, ep, morefrag,
		ieeerate2rtlrate(rate));

	priv->stats.txdatapkt++;
	
	//if (!check_nic_enought_desc(dev, PRI2EP[skb->priority])){
	if (!check_nic_enought_desc(dev, ep)){
		ieee80211_stop_queue(priv->ieee80211);
	}
		
	spin_unlock_irqrestore(&priv->tx_lock,flags);	
			
}

/* This is a rough attempt to TX a frame
 * This is called by the ieee 80211 stack to TX management frames.
 * If the ring is full packet are dropped (for data frame the queue
 * is stopped before this can happen).
 */
int rtl8180_hard_start_xmit(struct sk_buff *skb,struct net_device *dev)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct ieee80211_device *ieee = priv->ieee80211;
	int ret;
	unsigned long flags;
#if 0	
	struct ieee80211_hdr_3addr *frag_packet = (struct ieee80211_hdr_3addr*)skb->data;
#define BEACON_PACKET(fc)  ((fc&0xf0) == 0x80)
#endif	
	spin_lock_irqsave(&priv->tx_lock,flags);

#if 0	
	ret = rtl8180_tx(dev, (u32*)skb->data, skb->len, BEACON_PACKET(frag_packet->frame_ctl)? 
			BEACON_PRIORITY:MANAGE_PRIORITY, 0, ieeerate2rtlrate(ieee->basic_rate));
#endif	
	ret = rtl8180_tx(dev, (u32*)skb->data, skb->len, MANAGE_PRIORITY, 0, ieeerate2rtlrate(ieee->basic_rate));
//	ret = rtl8180_tx(dev, (u32*)skb->data, skb->len, BE_PRIORITY, 0, ieeerate2rtlrate(ieee->basic_rate));
/*
	int i;
	for(i=0;i<skb->len;i++)
		printk("%x ", skb->data[i]);
	printk("--------------------\n");
*/
	priv->ieee80211->stats.tx_bytes+=skb->len;
	priv->ieee80211->stats.tx_packets++;
	
	spin_unlock_irqrestore(&priv->tx_lock,flags);	
	
//	dev_kfree_skb_any(skb);
	return ret;
}


#if 0
// longpre 144+48 shortpre 72+24
u16 rtl8180_len2duration(u32 len, short rate,short* ext)
{
	u16 duration;
	u16 drift;
	*ext=0;
	
	switch(rate){
	case 0://1mbps
		*ext=0;
		duration = ((len+4)<<4) /0x2;
		drift = ((len+4)<<4) % 0x2;
		if(drift ==0 ) break;
		duration++;
		break;
		
	case 1://2mbps
		*ext=0;
		duration = ((len+4)<<4) /0x4;
		drift = ((len+4)<<4) % 0x4;
		if(drift ==0 ) break;
		duration++;
		break;
		
	case 2: //5.5mbps
		*ext=0;
		duration = ((len+4)<<4) /0xb;
		drift = ((len+4)<<4) % 0xb;
		if(drift ==0 ) 
			break;
		duration++;
		break;
		
	default:
	case 3://11mbps				
		*ext=0;
		duration = ((len+4)<<4) /0x16;
		drift = ((len+4)<<4) % 0x16;
		if(drift ==0 ) 
			break;
		duration++;
		if(drift > 6) 
			break;
		*ext=1;
		break;
	}
	
	return duration;
}
#endif

void rtl8180_try_wake_queue(struct net_device *dev, int pri);

void rtl8187_lptx_isr(struct urb *tx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)tx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);

	if(tx_urb->status == 0)
		priv->stats.txlpokint++;
	else
		priv->stats.txlperr++;
	kfree(tx_urb->transfer_buffer);
	usb_free_urb(tx_urb);
	atomic_dec(&priv->tx_pending[LOW_PRIORITY]);
	rtl8180_try_wake_queue(dev,LOW_PRIORITY);
}

void rtl8187_nptx_isr(struct urb *tx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)tx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);

	if(tx_urb->status == 0)
		priv->stats.txnpokint++;
	else
		priv->stats.txnperr++;
	kfree(tx_urb->transfer_buffer);
	usb_free_urb(tx_urb);
	atomic_dec(&priv->tx_pending[NORM_PRIORITY]);
	//rtl8180_try_wake_queue(dev,NORM_PRIORITY);
}

void rtl8187_votx_isr(struct urb *tx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)tx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);

	if(tx_urb->status == 0)
		priv->stats.txvookint++;
	else
		priv->stats.txvoerr++;
	kfree(tx_urb->transfer_buffer);
	usb_free_urb(tx_urb);
	atomic_dec(&priv->tx_pending[VO_PRIORITY]);
	rtl8180_try_wake_queue(dev,VO_PRIORITY);
}

void rtl8187_vitx_isr(struct urb *tx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)tx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);

	if(tx_urb->status == 0)
		priv->stats.txviokint++;
	else
		priv->stats.txvierr++;
	kfree(tx_urb->transfer_buffer);
	usb_free_urb(tx_urb);
	atomic_dec(&priv->tx_pending[VI_PRIORITY]);
	rtl8180_try_wake_queue(dev,VI_PRIORITY);
}

void rtl8187_betx_isr(struct urb *tx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)tx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);

	if(tx_urb->status == 0)
		priv->stats.txbeokint++;
	else
		priv->stats.txbeerr++;
	kfree(tx_urb->transfer_buffer);
	usb_free_urb(tx_urb);
	atomic_dec(&priv->tx_pending[BE_PRIORITY]);
	rtl8180_try_wake_queue(dev, BE_PRIORITY);
}

void rtl8187_bktx_isr(struct urb *tx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)tx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);

	if(tx_urb->status == 0)
		priv->stats.txbkokint++;
	else
		priv->stats.txbkerr++;
	kfree(tx_urb->transfer_buffer);
	usb_free_urb(tx_urb);
	atomic_dec(&priv->tx_pending[BK_PRIORITY]);
	rtl8180_try_wake_queue(dev,BK_PRIORITY);
}
void rtl8187_beacontx_isr(struct urb *tx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)tx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);
	
	if(tx_urb->status == 0)
		priv->stats.txbeaconokint++;
	else
		priv->stats.txbeaconerr++;
	kfree(tx_urb->transfer_buffer);
	usb_free_urb(tx_urb);
	atomic_dec(&priv->tx_pending[BEACON_PRIORITY]);
	//rtl8180_try_wake_queue(dev,BEACON_PRIORITY);
}

void rtl8187_managetx_isr(struct urb *tx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)tx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);

	if(tx_urb->status == 0)
		priv->stats.txmanageokint++;
	else
		priv->stats.txmanageerr++;
	kfree(tx_urb->transfer_buffer);
	usb_free_urb(tx_urb);
	atomic_dec(&priv->tx_pending[MANAGE_PRIORITY]);
//	rtl8180_try_wake_queue(dev,MANAGE_PRIORITY);
}

void rtl8187_beacon_stop(struct net_device *dev)
{
	u8 msr, msrm, msr2;
	struct r8180_priv *priv = ieee80211_priv(dev);

	msr  = read_nic_byte(dev, MSR);
	msrm = msr & MSR_LINK_MASK;
	msr2 = msr & ~MSR_LINK_MASK;

	if(NIC_8187B == priv->card_8187) {
		usb_kill_urb(priv->rx_urb[MAX_RX_URB]);
		
	}
	if ((msrm == (MSR_LINK_ADHOC<<MSR_LINK_SHIFT) ||
		(msrm == (MSR_LINK_MASTER<<MSR_LINK_SHIFT)))){
		write_nic_byte(dev, MSR, msr2 | MSR_LINK_NONE);
		write_nic_byte(dev, MSR, msr);	
	}
}


void rtl8187_net_update(struct net_device *dev)
{

	struct r8180_priv *priv = ieee80211_priv(dev);
	struct ieee80211_network *net;
	net = & priv->ieee80211->current_network;
	
	
	write_nic_dword(dev,BSSID,((u32*)net->bssid)[0]);
	write_nic_word(dev,BSSID+4,((u16*)net->bssid)[2]);
	//for(i=0;i<ETH_ALEN;i++)
	//	write_nic_byte(dev,BSSID+i,net->bssid[i]);

	rtl8180_update_msr(dev);
		
//	rtl8180_set_mode(dev,EPROM_CMD_CONFIG);
	write_nic_word(dev, AtimWnd, 2);
	write_nic_word(dev, AtimtrItv, 100);	
	write_nic_word(dev, BEACON_INTERVAL, net->beacon_interval);
//	write_nic_word(dev, BcnIntTime, 100);
	write_nic_word(dev, BcnIntTime, 0x3FF);
	

}

void rtl8187_beacon_tx(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	struct sk_buff *skb;
	int i = 0;
	u8 cr;

	rtl8187_net_update(dev);

	if(NIC_8187B == priv->card_8187) {
		//Cause TSF timer of MAC reset to 0
		cr=read_nic_byte(dev,CMD);
		cr = cr | (1<<CMD_RST_SHIFT);
		write_nic_byte(dev,CMD,cr);

		mdelay(200);

		if(read_nic_byte(dev,CMD) & (1<<CMD_RST_SHIFT)) 
			DMESGW("Card reset timeout for ad-hoc!");
		else 
			DMESG("Card successfully reset for ad-hoc");

		write_nic_byte(dev,CMD, (read_nic_byte(dev,CMD)|CR_RE|CR_TE));

		rtl8187_rx_manage_initiate(dev);
		
	} else {
		printk(KERN_WARNING "get the beacon!\n");
		skb = ieee80211_get_beacon(priv->ieee80211);
		if(!skb){ 
			DMESG("not enought memory for allocating beacon");
			return;
		}

#if 0	
		while(MAX_TX_URB!=atomic_read(&priv->tx_np_pending)){
			msleep_interruptible_rtl(HZ/2);
			if(i++ > 20){
				DMESG("get stuck to wait EP3 become ready");
				return ;
			}
		}
#endif
		write_nic_byte(dev, BQREQ, read_nic_byte(dev, BQREQ) | (1<<7));

		i=0;
		//while(!read_nic_byte(dev,BQREQ & (1<<7)))
		while( (read_nic_byte(dev, BQREQ) & (1<<7)) == 0 )
		{
			msleep_interruptible_rtl(HZ/2);
			if(i++ > 10){
				DMESGW("get stuck to wait HW beacon to be ready");
				return ;
			}
		}
		//tx 	
		rtl8180_tx(dev, (u32*)skb->data, skb->len, NORM_PRIORITY,
				0, ieeerate2rtlrate(priv->ieee80211->basic_rate));
		if(skb)
			dev_kfree_skb_any(skb);
	}
}
#if 0
void rtl8187_nptx_isr(struct urb *tx_urb, struct pt_regs *regs)
{
	struct net_device *dev = (struct net_device*)tx_urb->context;
	struct r8180_priv *priv = ieee80211_priv(dev);

	if(tx_urb->status == 0)
		priv->stats.txnpokint++;
	else
		priv->stats.txnperr++;
	kfree(tx_urb->transfer_buffer);
	usb_free_urb(tx_urb);
	atomic_dec(&priv->tx_np_pending);
	//rtl8180_try_wake_queue(dev,NORM_PRIORITY);
}
#endif
inline u8 rtl8180_IsWirelessBMode(u16 rate)
{
	if( ((rate <= 110) && (rate != 60) && (rate != 90)) || (rate == 220) )
		return 1;
	else return 0;
}

u16 N_DBPSOfRate(u16 DataRate);

u16 ComputeTxTime( 
	u16		FrameLength,
	u16		DataRate,
	u8		bManagementFrame,
	u8		bShortPreamble
)
{
	u16	FrameTime;
	u16	N_DBPS;
	u16	Ceiling;

	if( rtl8180_IsWirelessBMode(DataRate) )
	{
		if( bManagementFrame || !bShortPreamble || DataRate == 10 )
		{	// long preamble
			FrameTime = (u16)(144+48+(FrameLength*8/(DataRate/10)));		
		}
		else
		{	// Short preamble
			FrameTime = (u16)(72+24+(FrameLength*8/(DataRate/10)));
		}
		if( ( FrameLength*8 % (DataRate/10) ) != 0 ) //Get the Ceilling
				FrameTime ++;
	} else {	//802.11g DSSS-OFDM PLCP length field calculation.
		N_DBPS = N_DBPSOfRate(DataRate);
		Ceiling = (16 + 8*FrameLength + 6) / N_DBPS 
				+ (((16 + 8*FrameLength + 6) % N_DBPS) ? 1 : 0);
		FrameTime = (u16)(16 + 4 + 4*Ceiling + 6);
	}
	return FrameTime;
}

u16 N_DBPSOfRate(u16 DataRate)
{
	 u16 N_DBPS = 24;
	 
	 switch(DataRate)
	 {
	 case 60:
	  N_DBPS = 24;
	  break;
	 
	 case 90:
	  N_DBPS = 36;
	  break;
	 
	 case 120:
	  N_DBPS = 48;
	  break;
	 
	 case 180:
	  N_DBPS = 72;
	  break;
	 
	 case 240:
	  N_DBPS = 96;
	  break;
	 
	 case 360:
	  N_DBPS = 144;
	  break;
	 
	 case 480:
	  N_DBPS = 192;
	  break;
	 
	 case 540:
	  N_DBPS = 216;
	  break;
	 
	 default:
	  break;
	 }
	 
	 return N_DBPS;
}
// NOte!!!
// the rate filled in is the rtl_rate.
// while the priv->ieee80211->basic_rate,used in the following code is ieee80211 rate.
short rtl8180_tx(struct net_device *dev, u32* txbuf, int len, priority_t priority,
		 short morefrag, short rate)
{
	u32 *tx;
	//	u16 duration;
	//	short ext;
	int pend ;
	int status;
	struct urb *tx_urb;
	int urb_len;	
	struct r8180_priv *priv = ieee80211_priv(dev);
	struct ieee80211_hdr_3addr_QOS *frag_hdr = (struct ieee80211_hdr_3addr_QOS *)txbuf;
	struct ieee80211_device *ieee;//added for descriptor
	u8 dest[ETH_ALEN];

	bool			bUseShortPreamble = false;
	bool			bCTSEnable = false;
	bool			bRTSEnable = false;
	//u16			RTSRate = 22;
	//u8			RetryLimit = 0;
	u16 			Duration = 0; 
	u16			RtsDur = 0;
	u16			ThisFrameTime = 0;	
	u16			TxDescDuration = 0;
	//for test
	//int 			i;

	//}	int rate = ieeerate2rtlrate(priv->ieee80211->rate);


	ieee = priv->ieee80211;
	//	pend = atomic_read((priority == NORM_PRIORITY)? &priv->tx_np_pending : &priv->tx_lp_pending);
	pend = atomic_read(&priv->tx_pending[priority]);
	/* we are locked here so the two atomic_read and inc are executed without interleaves */
	if( pend > MAX_TX_URB){
		if(NIC_8187 == priv->card_8187) {
			if(priority == NORM_PRIORITY)
				priv->stats.txnpdrop++;
			else
				priv->stats.txlpdrop++;

		} else {
			switch (priority) {
				case VO_PRIORITY:
					priv->stats.txvodrop++;
					break;
				case VI_PRIORITY:
					priv->stats.txvidrop++;
					break;
				case BE_PRIORITY:
					priv->stats.txbedrop++;
					break;
				default://BK_PRIORITY
					priv->stats.txbkdrop++;
					break;	
			}
		}
		return -1;
	}

	urb_len = len + ((NIC_8187 == priv->card_8187)?(4*3):(4*8));
	if((0 == urb_len%64)||(0 == urb_len%512)) {
		urb_len += 1;	  
	}

	tx = kmalloc(urb_len, GFP_ATOMIC);
	if(!tx) return -ENOMEM;
	memset(tx, 0, sizeof(u32) * 8);

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
	tx_urb = usb_alloc_urb(0,GFP_ATOMIC);
#else
	tx_urb = usb_alloc_urb(0);
#endif

	if(!tx_urb){
		kfree(tx);
		return -ENOMEM;
	}

#define sCrcLng         4	
#define sAckCtsLng	112		// bits in ACK and CTS frames
	// Check multicast/broadcast
	if (ieee->iw_mode == IW_MODE_INFRA) {
		/* To DS: Addr1 = BSSID, Addr2 = SA,
		   Addr3 = DA */
		//memcpy(&dest, frag_hdr->addr3, ETH_ALEN);
		memcpy(&dest, frag_hdr->addr1, ETH_ALEN);
	} else if (ieee->iw_mode == IW_MODE_ADHOC) {
		/* not From/To DS: Addr1 = DA, Addr2 = SA,
		   Addr3 = BSSID */
		memcpy(&dest, frag_hdr->addr1, ETH_ALEN);
	}

	if (is_multicast_ether_addr(dest) ||
			is_broadcast_ether_addr(dest)) 
	{
		Duration = 0;
		RtsDur = 0;
		bRTSEnable = false;
		bCTSEnable = false;

		ThisFrameTime = ComputeTxTime(len + sCrcLng, rtl8180_rate2rate(rate), false, bUseShortPreamble);
		TxDescDuration = ThisFrameTime;
	} else {// Unicast packet
		//u8 AckRate;
		u16 AckTime;

		// Figure out ACK rate according to BSS basic rate and Tx rate, 2006.03.08 by rcnjko.
		//AckRate = ComputeAckRate( pMgntInfo->mBrates, (u1Byte)(pTcb->DataRate) );
		// Figure out ACK time according to the AckRate and assume long preamble is used on receiver, 2006.03.08, by rcnjko.
		//AckTime = ComputeTxTime( sAckCtsLng/8, AckRate, FALSE, FALSE);
		//For simplicity, just use the 1M basic rate
		AckTime = ComputeTxTime(14, 10,false, false);	// AckCTSLng = 14 use 1M bps send
		//AckTime = ComputeTxTime(14, 2,false, false);	// AckCTSLng = 14 use 1M bps send

		if ( ((len + sCrcLng) > priv->rts) && priv->rts )
		{ // RTS/CTS.
			u16 RtsTime, CtsTime;
			//u16 CtsRate;
			bRTSEnable = true;
			bCTSEnable = false;

			// Rate and time required for RTS.
			RtsTime = ComputeTxTime( sAckCtsLng/8,priv->ieee80211->basic_rate, false, false);
			// Rate and time required for CTS.
			CtsTime = ComputeTxTime(14, 10,false, false);	// AckCTSLng = 14 use 1M bps send

			// Figure out time required to transmit this frame.
			ThisFrameTime = ComputeTxTime(len + sCrcLng, 
					rtl8180_rate2rate(rate), 
					false, 
					bUseShortPreamble);

			// RTS-CTS-ThisFrame-ACK.
			RtsDur = CtsTime + ThisFrameTime + AckTime + 3*aSifsTime;

			TxDescDuration = RtsTime + RtsDur;
		}
		else {// Normal case.
			bCTSEnable = false;
			bRTSEnable = false;
			RtsDur = 0;

			ThisFrameTime = ComputeTxTime(len + sCrcLng, rtl8180_rate2rate(rate), false, bUseShortPreamble);
			TxDescDuration = ThisFrameTime + aSifsTime + AckTime;
		}

		if(!(frag_hdr->frame_ctl & IEEE80211_FCTL_MOREFRAGS)) { //no more fragment
			// ThisFrame-ACK.
			Duration = aSifsTime + AckTime;
		} else { // One or more fragments remained.
			u16 NextFragTime;
			NextFragTime = ComputeTxTime( len + sCrcLng, //pretend following packet length equal current packet
					rtl8180_rate2rate(rate), 
					false, 
					bUseShortPreamble );

			//ThisFrag-ACk-NextFrag-ACK.
			Duration = NextFragTime + 3*aSifsTime + 2*AckTime;
		}

	} // End of Unicast packet


	//fill the tx desriptor
	tx[0] |= len & 0xfff;
	tx[0] |= (1<<15);

	if (priv->ieee80211->current_network.capability&WLAN_CAPABILITY_SHORT_PREAMBLE){
		if (priv->plcp_preamble_mode==1 && rate!=0) {	//  short mode now, not long!
			tx[0] |= (1<<16);	
		}			// enable short preamble mode.
	}

	if(morefrag) tx[0] |= (1<<17);
	//printk(KERN_WARNING "rtl_rate = %d\n", rate);
	tx[0] |= (rate << 24); //TX rate
	frag_hdr->duration_id = Duration;

	if(NIC_8187B == priv->card_8187) {
		if(bCTSEnable) {
			tx[0] |= (1<<18);
		}

		if(bRTSEnable) //rts enable
		{
			tx[0] |= ((ieeerate2rtlrate(priv->ieee80211->basic_rate))<<19);//RTS RATE
			tx[0] |= (1<<23);//rts enable
			tx[1] |= RtsDur;//RTS Duration
		}	
		tx[3] |= (TxDescDuration<<16); //DURATION
		tx[5] |= (11<<8);//(priv->retry_data<<8); //retry lim ;	

		//frag_hdr->duration_id = Duration;
		memcpy(tx+8,txbuf,len);
	} else {
		if ( (len>priv->rts) && priv->rts && priority==LOW_PRIORITY){
			tx[0] |= (1<<23);	//enalbe RTS function
			tx[1] |= RtsDur; 	//Need to edit here!  ----hikaru
		}
		else {
			tx[1]=0;
		}
		tx[0] |= (ieeerate2rtlrate(priv->ieee80211->basic_rate) << 19); /* RTS RATE - should be basic rate */

		tx[2] = 3;  // CW min
		tx[2] |= (7<<4); //CW max
		tx[2] |= (11<<8);//(priv->retry_data<<8); //retry lim

		//	printk("%x\n%x\n",tx[0],tx[1]);

#ifdef DUMP_TX
		int i;
		printk("<Tx pkt>--rate %x---",rate);
		for (i = 0; i < (len + 3); i++)
			printk("%2x", ((u8*)tx)[i]);
		printk("---------------\n");
#endif
		memcpy(tx+3,txbuf,len);
	}

	if(NIC_8187 == priv->card_8187) {
		usb_fill_bulk_urb(tx_urb,priv->udev,
				usb_sndbulkpipe(priv->udev,priority), tx,
				urb_len, (priority == LOW_PRIORITY)?rtl8187_lptx_isr:rtl8187_nptx_isr, dev);

	} else {
		//printk(KERN_WARNING "Tx packet use by submit urb!\n");
		/* FIXME check what EP is for low/norm PRI */
		usb_fill_bulk_urb(tx_urb,priv->udev,
				usb_sndbulkpipe(priv->udev,priority), tx,
				urb_len, TXISR_SELECT(priority), dev);
	}

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
	status = usb_submit_urb(tx_urb, GFP_ATOMIC);
#else
	status = usb_submit_urb(tx_urb);
#endif

	if (!status){
		//atomic_inc((priority == NORM_PRIORITY)? &priv->tx_np_pending : &priv->tx_lp_pending);
		atomic_inc(&priv->tx_pending[priority]);
		return 0;
	}else{
		DMESGE("Error TX URB %d, error %d",
				//atomic_read((priority == NORM_PRIORITY)? &priv->tx_np_pending : &priv->tx_lp_pending),
				atomic_read(&priv->tx_pending[priority]),
				status);
		return -1;
	}
}

 



short rtl8187_usb_initendpoints(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	int i;
	
	priv->rx_urb = (struct urb**) kmalloc (sizeof(struct urb*) * (MAX_RX_URB+1), GFP_KERNEL);

#ifndef JACKSON_NEW_RX
	for(i=0;i<(MAX_RX_URB+1);i++){

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
		priv->rx_urb[i] = usb_alloc_urb(0,GFP_KERNEL);
#else
		priv->rx_urb[i] = usb_alloc_urb(0);
#endif

		priv->rx_urb[i]->transfer_buffer = kmalloc(RX_URB_SIZE, GFP_KERNEL);
			
		priv->rx_urb[i]->transfer_buffer_length = RX_URB_SIZE;
	}
#endif

#ifdef THOMAS_BEACON
	
	u32 oldaddr,newaddr;
	priv->rx_urb[MAX_RX_URB] = usb_alloc_urb(0, GFP_KERNEL);		
	priv->oldaddr = kmalloc(16, GFP_KERNEL);
	oldaddr = (u32)priv->oldaddr;
	int align = oldaddr&3;
	if(align != 0 ){
		newaddr = oldaddr + 4 - align;
		priv->rx_urb[MAX_RX_URB]->transfer_buffer_length = 16-4+align;
	}	
	else{
		newaddr = oldaddr;
		priv->rx_urb[MAX_RX_URB]->transfer_buffer_length = 16;
	}
	priv->rx_urb[MAX_RX_URB]->transfer_buffer = (u32*)newaddr;
#endif
       
        memset(priv->rx_urb, 0, sizeof(struct urb*) * MAX_RX_URB);
        priv->pp_rxskb = (struct sk_buff **)kmalloc(sizeof(struct sk_buff *) * MAX_RX_URB, GFP_KERNEL);
        if (priv->pp_rxskb == NULL)
                goto destroy;

        memset(priv->pp_rxskb, 0, sizeof(struct sk_buff*) * MAX_RX_URB);

        goto _middle;


destroy:
        if (priv->pp_rxskb) {
                kfree(priv->pp_rxskb);
        }
        if (priv->rx_urb) {
                kfree(priv->rx_urb);
        }
        priv->pp_rxskb = priv->rx_urb = NULL;

        DMESGE("Endpoint Alloc Failure");
        return -ENOMEM;
	

_middle:

	return 0;
	
}
#ifdef THOMAS_BEACON
void rtl8187_usb_deleteendpoints(struct net_device *dev)
{	
	int i;
	struct r8180_priv *priv = ieee80211_priv(dev);
	
        if( in_interrupt() )
		printk(KERN_ALERT " %d in interrupt \n",in_interrupt() );
	if(priv->rx_urb){
		for(i=0;i<(MAX_RX_URB+1);i++){
			usb_kill_urb(priv->rx_urb[i]);
			usb_free_urb(priv->rx_urb[i]);
		}
		kfree(priv->rx_urb);
		priv->rx_urb = NULL;	
	}	
	if(priv->oldaddr){
		kfree(priv->oldaddr);
		priv->oldaddr = NULL;
	}	
        if (priv->pp_rxskb) {
                kfree(priv->pp_rxskb);
                priv->pp_rxskb = 0;
	}
}
#else
void rtl8187_usb_deleteendpoints(struct net_device *dev)
{
	int i;
	struct r8180_priv *priv = ieee80211_priv(dev);

#ifndef JACKSON_NEW_RX
	
	if(priv->rx_urb){
		for(i=0;i<(MAX_RX_URB+1);i++){
			usb_kill_urb(priv->rx_urb[i]);
			kfree(priv->rx_urb[i]->transfer_buffer);
			usb_free_urb(priv->rx_urb[i]);
		}
		kfree(priv->rx_urb);
		priv->rx_urb = NULL;
		
	}
#else
        if(priv->rx_urb){
                kfree(priv->rx_urb);
                priv->rx_urb = NULL;
        }
	if(priv->oldaddr){
		kfree(priv->oldaddr);
		priv->oldaddr = NULL;
	}	
        if (priv->pp_rxskb) {
                kfree(priv->pp_rxskb);
                priv->pp_rxskb = 0;

        }

#endif	
}
#endif

void rtl8187_set_rate(struct net_device *dev)
{
	int i;
	u16 word;
	int basic_rate,min_rr_rate,max_rr_rate;

//	struct r8180_priv *priv = ieee80211_priv(dev);
	
	//if (ieee80211_is_54g(priv->ieee80211->current_network) && 
//		priv->ieee80211->state == IEEE80211_LINKED){
	basic_rate = ieeerate2rtlrate(240);
	min_rr_rate = ieeerate2rtlrate(60);
	max_rr_rate = ieeerate2rtlrate(240);
	
//	
//	}else{
//		basic_rate = ieeerate2rtlrate(20);
//		min_rr_rate = ieeerate2rtlrate(10);
//		max_rr_rate = ieeerate2rtlrate(110);
//	}

	write_nic_byte(dev, RESP_RATE,
			max_rr_rate<<MAX_RESP_RATE_SHIFT| min_rr_rate<<MIN_RESP_RATE_SHIFT);

	//word  = read_nic_word(dev, BRSR);
	word  = read_nic_word(dev, BRSR_8187);
	word &= ~BRSR_MBR_8185;
		

	for(i=0;i<=basic_rate;i++)
		word |= (1<<i);

	//write_nic_word(dev, BRSR, word);
	write_nic_word(dev, BRSR_8187, word);
	//DMESG("RR:%x BRSR: %x", read_nic_byte(dev,RESP_RATE), read_nic_word(dev,BRSR));
}


void rtl8187_link_change(struct net_device *dev)
{
//	int i;
	
	struct r8180_priv *priv = ieee80211_priv(dev);
	//write_nic_word(dev, BintrItv, net->beacon_interval);
	rtl8187_net_update(dev);
	/*update timing params*/
	rtl8180_set_chan(dev, priv->chan);

	rtl8187_set_rxconf(dev);
}

#if LINUX_VERSION_CODE >=KERNEL_VERSION(2,6,20)
void rtl8180_wmm_param_update(struct struct_work * work)
{
	struct ieee80211_device * ieee = container_of(work, struct ieee80211_device,wmm_param_update_wq);
	struct r8180_priv *priv = (struct ieee80211_device*)
		(ieee->priv);
	struct net_device *dev = ieee->dev;
#else
void rtl8180_wmm_param_update(struct ieee80211_device *ieee)
{
	struct net_device *dev = ieee->dev;
	struct r8180_priv *priv = ieee80211_priv(dev);
#endif
	u8 *ac_param = (u8 *)(ieee->current_network.wmm_param);
	u8 mode = ieee->current_network.mode;
	AC_CODING	eACI;
	AC_PARAM	AcParam;
	PAC_PARAM	pAcParam;
	u8 i;

	//8187 need not to update wmm param, added by David, 2006.9.8
	if(NIC_8187 == priv->card_8187) {
		return; 
	}

	if(!ieee->current_network.QoS_Enable) 
	{
		//legacy ac_xx_param update
		
		AcParam.longData = 0;
		AcParam.f.AciAifsn.f.AIFSN = 2; // Follow 802.11 DIFS.
		AcParam.f.AciAifsn.f.ACM = 0;
		AcParam.f.Ecw.f.ECWmin = 3; // Follow 802.11 CWmin.
		AcParam.f.Ecw.f.ECWmax = 7; // Follow 802.11 CWmax.
		AcParam.f.TXOPLimit = 0;
		for(eACI = 0; eACI < AC_MAX; eACI++)
		{
			AcParam.f.AciAifsn.f.ACI = (u8)eACI;
			{
				u8		u1bAIFS;
				u32		u4bAcParam;


				pAcParam = (PAC_PARAM)(&AcParam);
				// Retrive paramters to udpate.
				u1bAIFS = pAcParam->f.AciAifsn.f.AIFSN *(((mode&IEEE_G) == IEEE_G)?9:20)  + aSifsTime; 
				u4bAcParam = (	(((u32)(pAcParam->f.TXOPLimit)) << AC_PARAM_TXOP_LIMIT_OFFSET)	| 
						(((u32)(pAcParam->f.Ecw.f.ECWmax)) << AC_PARAM_ECW_MAX_OFFSET)	|  
						(((u32)(pAcParam->f.Ecw.f.ECWmin)) << AC_PARAM_ECW_MIN_OFFSET)	|  
						(((u32)u1bAIFS) << AC_PARAM_AIFS_OFFSET));

				switch(eACI)
				{
					case AC1_BK:
						write_nic_dword(dev, AC_BK_PARAM, u4bAcParam);
						break;

					case AC0_BE:
						write_nic_dword(dev, AC_BE_PARAM, u4bAcParam);
						break;

					case AC2_VI:
						write_nic_dword(dev, AC_VI_PARAM, u4bAcParam);
						break;

					case AC3_VO:
						write_nic_dword(dev, AC_VO_PARAM, u4bAcParam);
						break;

					default:
						printk(KERN_WARNING "SetHwReg8185(): invalid ACI: %d !\n", eACI);
						break;
				}
			}
		}

		return;
	}
	//
	for(i = 0; i < AC_MAX; i++)
	{
		//AcParam.longData = 0;
		
		
		pAcParam = (AC_PARAM * )ac_param;
		{
			AC_CODING	eACI;
			u8		u1bAIFS;
			u32		u4bAcParam;

			// Retrive paramters to udpate.
			eACI = pAcParam->f.AciAifsn.f.ACI; 
			//Mode G/A: slotTimeTimer = 9; Mode B: 20
			u1bAIFS = pAcParam->f.AciAifsn.f.AIFSN * (((mode&IEEE_G) == IEEE_G)?9:20) + aSifsTime; 
			u4bAcParam = (	(((u32)(pAcParam->f.TXOPLimit)) << AC_PARAM_TXOP_LIMIT_OFFSET)	| 
					(((u32)(pAcParam->f.Ecw.f.ECWmax)) << AC_PARAM_ECW_MAX_OFFSET)	|  
					(((u32)(pAcParam->f.Ecw.f.ECWmin)) << AC_PARAM_ECW_MIN_OFFSET)	|  
					(((u32)u1bAIFS) << AC_PARAM_AIFS_OFFSET));

			switch(eACI)
			{
				case AC1_BK:
					write_nic_dword(dev, AC_BK_PARAM, u4bAcParam);
					//printk(KERN_WARNING "[%04x]:0x%08x\n",AC_BK_PARAM,read_nic_dword(dev, AC_BK_PARAM));
					break;

				case AC0_BE:
					write_nic_dword(dev, AC_BE_PARAM, u4bAcParam);
					//printk(KERN_WARNING "[%04x]:0x%08x\n",AC_BE_PARAM,read_nic_dword(dev, AC_BE_PARAM));
					break;

				case AC2_VI:
					write_nic_dword(dev, AC_VI_PARAM, u4bAcParam);
					//printk(KERN_WARNING "[%04x]:0x%08x\n",AC_VI_PARAM,read_nic_dword(dev, AC_VI_PARAM));
					break;

				case AC3_VO:
					write_nic_dword(dev, AC_VO_PARAM, u4bAcParam);
					//printk(KERN_WARNING "[%04x]:0x%08x\n",AC_VO_PARAM,read_nic_dword(dev, AC_VO_PARAM));
					break;

				default:
					printk(KERN_WARNING "SetHwReg8185(): invalid ACI: %d !\n", eACI);
					break;
			}
		}
		ac_param += (sizeof(AC_PARAM));
	}
}

void rtl8180_irq_rx_tasklet_new(struct r8180_priv *priv);
void rtl8180_irq_rx_tasklet(struct r8180_priv *priv);

short rtl8180_init(struct net_device *dev)
{
		
	struct r8180_priv *priv = ieee80211_priv(dev);
	int i, j;
	u16 word;
	int ch;
	//u16 version;
	u8 hw_version;
	//u8 config3;
	struct usb_device *udev;
	u16 idProduct;
	u8 chan_plan_index;
	
	//FIXME: these constants are placed in a bad pleace.

//	priv->txbuffsize = 1024;
//	priv->txringcount = 32;
//	priv->rxbuffersize = 1024;
//	priv->rxringcount = 32; 
//	priv->txbeaconcount = 3;
//	priv->rx_skb_complete = 1;
	//priv->txnp_pending.ispending=0; 
	/* ^^ the SKB does not containt a partial RXed
	 * packet (is empty)
	 */
#if 0
	if(!channels){
		DMESG("No channels, aborting");
		return -1;
	}
	ch=channels;
	 // set channels 1..14 allowed in given locale
	for (i=1; i<=14; i++) {
		(priv->ieee80211->channel_map)[i] = (u8)(ch & 0x01);
		ch >>= 1;
	}
#endif	
	//memcpy(priv->stats,0,sizeof(struct Stats));
	
	//priv->irq_enabled=0;
	
//	priv->stats.rxdmafail=0;
	priv->stats.txrdu=0;
//	priv->stats.rxrdu=0;
//	priv->stats.rxnolast=0;
//	priv->stats.rxnodata=0;
	//priv->stats.rxreset=0;
	//priv->stats.rxwrkaround=0;
//	priv->stats.rxnopointer=0;
	priv->stats.txbeerr=0;
	priv->stats.txbkerr=0;
	priv->stats.txvierr=0;
	priv->stats.txvoerr=0;
	priv->stats.txmanageerr=0;
	priv->stats.txbeaconerr=0;
	priv->stats.txresumed=0;
//	priv->stats.rxerr=0;
//	priv->stats.rxoverflow=0;
//	priv->stats.rxint=0;
	priv->stats.txbeokint=0;
	priv->stats.txbkokint=0;
	priv->stats.txviokint=0;
	priv->stats.txvookint=0;
	priv->stats.txmanageokint=0;
	priv->stats.txbeaconokint=0;
	/*priv->stats.txhpokint=0;
	priv->stats.txhperr=0;*/
	priv->stats.rxurberr=0;
	priv->stats.rxstaterr=0;
	priv->stats.txoverflow=0;
	priv->stats.rxok=0;
//	priv->stats.txbeaconerr=0;
//	priv->stats.txlperr=0;
//	priv->stats.txlpokint=0;
	
	priv->ieee80211->iw_mode = IW_MODE_INFRA;
	
	priv->retry_rts = DEFAULT_RETRY_RTS;
	priv->retry_data = DEFAULT_RETRY_DATA;
	priv->ieee80211->rate = 110; //11 mbps
	priv->ieee80211->short_slot = 1;
	priv->ieee80211->mode = IEEE_G;
	priv->promisc = (dev->flags & IFF_PROMISC) ? 1:0;
	spin_lock_init(&priv->tx_lock);
#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0))
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,20))
	INIT_WORK(&priv->reset_wq,(void(*)(void*)) rtl8180_restart);
#else
	INIT_WORK(&priv->reset_wq,(void(*)(void*)) rtl8180_restart,dev);
#endif
#else
	tq_init(&priv->reset_wq,(void(*)(void*)) rtl8180_restart,dev);
#endif
	sema_init(&priv->wx_sem,1);
#ifdef THOMAS_TASKLET
	tasklet_init(&priv->irq_rx_tasklet,
		     (void(*)(unsigned long))rtl8180_irq_rx_tasklet_new,
		     (unsigned long)priv);
#else
	tasklet_init(&priv->irq_rx_tasklet,
		     (void(*)(unsigned long))rtl8180_irq_rx_tasklet,
		     (unsigned long)priv);
#endif
	//priv->ieee80211->func = 
	//	kmalloc(sizeof(struct ieee80211_helper_functions),GFP_KERNEL);
	//memset(priv->ieee80211->func, 0,
	  //     sizeof(struct ieee80211_helper_functions));
	priv->ieee80211->current_network.beacon_interval = DEFAULT_BEACONINTERVAL;	
	priv->ieee80211->iw_mode = IW_MODE_INFRA;
	priv->ieee80211->softmac_features  = IEEE_SOFTMAC_SCAN | 
		IEEE_SOFTMAC_ASSOCIATE | IEEE_SOFTMAC_PROBERQ | 
		IEEE_SOFTMAC_PROBERS | IEEE_SOFTMAC_TX_QUEUE; /* |
		IEEE_SOFTMAC_BEACONS;*/ //|  //IEEE_SOFTMAC_SINGLE_QUEUE;
	
	priv->ieee80211->active_scan = 1;
	priv->ieee80211->rate = 110; //11 mbps
	priv->ieee80211->modulation = IEEE80211_CCK_MODULATION | IEEE80211_OFDM_MODULATION;
	priv->ieee80211->host_encrypt = 1;
	priv->ieee80211->host_decrypt = 1;
	priv->ieee80211->start_send_beacons = rtl8187_beacon_tx;
	priv->ieee80211->stop_send_beacons = rtl8187_beacon_stop;
	priv->ieee80211->softmac_hard_start_xmit = rtl8180_hard_start_xmit;
	priv->ieee80211->set_chan = rtl8180_set_chan;
	priv->ieee80211->link_change = rtl8187_link_change;
	priv->ieee80211->softmac_data_hard_start_xmit = rtl8180_hard_data_xmit;
	priv->ieee80211->data_hard_stop = rtl8180_data_hard_stop;
	priv->ieee80211->data_hard_resume = rtl8180_data_hard_resume;

#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0))
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)	
	INIT_WORK(&priv->ieee80211->wmm_param_update_wq,\
                  (void(*)(void*)) rtl8180_wmm_param_update,\
                  priv->ieee80211);
#else
	INIT_WORK(&priv->ieee80211->wmm_param_update_wq,\
                  (void(*)(void*)) rtl8180_wmm_param_update);
#endif
#else
	tq_init(&priv->ieee80211->wmm_param_update_wq,\
                (void(*)(void*)) rtl8180_wmm_param_update,\
                priv->ieee80211);
#endif
	priv->ieee80211->init_wmmparam_flag = 0;
	//{test for softbeacon by David 2006.8.16
	//priv->ieee80211->start_send_beacons = NULL;
	//priv->ieee80211->stop_send_beacons = NULL;
	//}
	priv->ieee80211->fts = DEFAULT_FRAG_THRESHOLD;
	
	//priv->card_8185 = 2;
	priv->phy_ver = 2;
	priv->card_type = USB;
//{add for 87B	
	priv->ShortRetryLimit = 7;
	priv->LongRetryLimit = 7;
	priv->EarlyRxThreshold = 7;
	
	priv->TransmitConfig = 
		TCR_DurProcMode |	//for RTL8185B, duration setting by HW
		TCR_DISReqQsize |
                (TCR_MXDMA_2048<<TCR_MXDMA_SHIFT)|  // Max DMA Burst Size per Tx DMA Burst, 7: reservied.
		(priv->ShortRetryLimit<<TX_SRLRETRY_SHIFT)|	// Short retry limit
		(priv->LongRetryLimit<<TX_LRLRETRY_SHIFT) |	// Long retry limit
		(false ? TCR_SWPLCPLEN : 0);	// FALSE: HW provies PLCP length and LENGEXT, TURE: SW proiveds them

	priv->ReceiveConfig	=
		RCR_AMF | RCR_ADF |		//accept management/data
		RCR_ACF |			//accept control frame for SW AP needs PS-poll, 2005.07.07, by rcnjko.
		RCR_AB | RCR_AM | RCR_APM |	//accept BC/MC/UC
		//RCR_AICV | RCR_ACRC32 | 	//accept ICV/CRC error packet
		RCR_MXDMA | // Max DMA Burst Size per Rx DMA Burst, 7: unlimited.
		(priv->EarlyRxThreshold<<RX_FIFO_THRESHOLD_SHIFT) | // Rx FIFO Threshold, 7: No Rx threshold.
		(priv->EarlyRxThreshold == 7 ? RCR_ONLYERLPKT:0);

	priv->AcmControl = 0;
//}	
	hw_version =( read_nic_dword(dev, TCR) & TCR_HWVERID_MASK)>>TCR_HWVERID_SHIFT;
	switch (hw_version) {
		case 0x06:
			priv->card_8187_Bversion = VERSION_8187B_B;
			break;
		case 0x05:
			priv->card_8187_Bversion = VERSION_8187_D;
			break;
		default:
			priv->card_8187_Bversion = VERSION_8187_B;
			break;
	}

	priv->enable_gpio0 = 0;

	/*the eeprom type is stored in RCR register bit #6 */ 
	if (RCR_9356SEL & read_nic_dword(dev, RCR)){
		priv->epromtype=EPROM_93c56;
		DMESG("Reported EEPROM chip is a 93c56 (2Kbit)");
	}else{
		priv->epromtype=EPROM_93c46;
		DMESG("Reported EEPROM chip is a 93c46 (1Kbit)");
	}
	
	dev->get_stats = rtl8180_stats;

	chan_plan_index = eprom_read(dev,EPROM_CHANNEL_PLAN) & 0xff;
	if(chan_plan_index & 0x80) {
		chan_plan_index &= 0x7f;
		if (DefaultChannelPlan[chan_plan_index].Len != 0){
			// force channel plan map
			for (i=0;i<DefaultChannelPlan[chan_plan_index].Len;i++) 
				priv->ieee80211->channel_map[DefaultChannelPlan[chan_plan_index].Channel[i]] = 1;
		} else {
			DMESG("No channels, aborting");
			return -1;
		}
	} else {
		//default channel plan setting
		if(!channels){
			DMESG("No channels, aborting");
			return -1;
		}
		ch=channels;
		// set channels 1..14 allowed in given locale
		for (i=1; i<=14; i++) {
			(priv->ieee80211->channel_map)[i] = (u8)(ch & 0x01);
			ch >>= 1;
		}
	}

	dev->dev_addr[0]=eprom_read(dev,MAC_ADR) & 0xff;
	dev->dev_addr[1]=(eprom_read(dev,MAC_ADR) & 0xff00)>>8;
	dev->dev_addr[2]=eprom_read(dev,MAC_ADR+1) & 0xff;
	dev->dev_addr[3]=(eprom_read(dev,MAC_ADR+1) & 0xff00)>>8;
	dev->dev_addr[4]=eprom_read(dev,MAC_ADR+2) & 0xff;
	dev->dev_addr[5]=((eprom_read(dev,MAC_ADR+2) & 0xff00)>>8)+1;
	
	DMESG("Card MAC address is "MAC_FMT, MAC_ARG(dev->dev_addr));
	
	for(i=1,j=0; i<6; i+=2,j++){
		
		word = eprom_read(dev,EPROM_TXPW0 + j);
		priv->chtxpwr[i]=word & 0xf;
		priv->chtxpwr_ofdm[i]=(word & 0xf0)>>4;
		priv->chtxpwr[i+1]=(word & 0xf00)>>8;
		priv->chtxpwr_ofdm[i+1]=(word & 0xf000)>>12;
	}
	
	for(i=1,j=0; i<4; i+=2,j++){
			
		word = eprom_read(dev,EPROM_TXPW1 + j);
		priv->chtxpwr[i+6]=word & 0xf;
		priv->chtxpwr_ofdm[i+6]=(word & 0xf0)>>4;
		priv->chtxpwr[i+6+1]=(word & 0xf00)>>8;
		priv->chtxpwr_ofdm[i+6+1]=(word & 0xf000)>>12;
	}
	
	for(i=1,j=0; i<4; i+=2,j++){
			
		word = eprom_read(dev,EPROM_TXPW2 + j);
		priv->chtxpwr[i+6+4]=word & 0xf;
		priv->chtxpwr_ofdm[i+6+4]=(word & 0xf0)>>4;
		priv->chtxpwr[i+6+4+1]=(word & 0xf00)>>8;
		priv->chtxpwr_ofdm[i+6+4+1]=(word & 0xf000)>>12;
	}

	priv->rf_chip = 0xff & eprom_read(dev,EPROM_RFCHIPID);
	
	word = eprom_read(dev,EPROM_TXPW_BASE);
	priv->cck_txpwr_base = word & 0xf;
	priv->ofdm_txpwr_base = (word>>4) & 0xf;
	
//{put the card to detect different card here, mainly I/O processing
	udev = priv->udev;
	idProduct = le16_to_cpu(udev->descriptor.idProduct);
	
	switch (idProduct) {
		case 0x8189:
			/* check RF frontend chipset */
			priv->card_8187 = NIC_8187B;
			priv->rf_init = rtl8225z2_rf_init;
			priv->rf_set_chan = rtl8225z2_rf_set_chan;
			priv->rf_set_sens = NULL;
			break;

		case 0x8187:
			//legacy 8187 NIC
			//{ delete break intentionly
			//break;
			//}

		default:
			/* check RF frontend chipset */
			priv->ieee80211->softmac_features |= IEEE_SOFTMAC_SINGLE_QUEUE;
			priv->card_8187 = NIC_8187;
			switch (priv->rf_chip) {
				case EPROM_RFCHIPID_RTL8225U:
					DMESG("Card reports RF frontend Realtek 8225");
					DMESGW("This driver has EXPERIMENTAL support for this chipset.");
					DMESGW("use it with care and at your own risk and");
					DMESGW("**PLEASE** REPORT SUCCESS/INSUCCESS TO Realtek");
					if(rtl8225_is_V_z2(dev)){
						priv->rf_init = rtl8225z2_rf_init;
						priv->rf_set_chan = rtl8225z2_rf_set_chan;
						priv->rf_set_sens = NULL;
						DMESG("This seems a new V2 radio");
					}else{
						priv->rf_init = rtl8225_rf_init;
						priv->rf_set_chan = rtl8225_rf_set_chan;
						priv->rf_set_sens = rtl8225_rf_set_sens;
						DMESG("This seems a legacy 1st version radio");
					}
					break;

				default:
					DMESGW("Unknown RF module %x",priv->rf_chip);
					DMESGW("Exiting...");
					return -1;
			}
			break;
	}

	priv->rf_close = rtl8225_rf_close;
	priv->max_sens = RTL8225_RF_MAX_SENS;
	priv->sens = RTL8225_RF_DEF_SENS;

	DMESG("PAPE from CONFIG2: %x",read_nic_byte(dev,CONFIG2)&0x7);
	
	if(rtl8187_usb_initendpoints(dev)!=0){ 
		DMESG("Endopoints initialization failed");
		return -ENOMEM;
	}
	
#ifdef DEBUG_EPROM
	dump_eprom(dev);
#endif 
	return 0;

}

void rtl8185_rf_pins_enable(struct net_device *dev)
{
/*	u16 tmp;
	tmp = read_nic_word(dev, RFPinsEnable);*/
	write_nic_word(dev, RFPinsEnable, 0x1ff7);// | tmp);
}


void rtl8185_set_anaparam2(struct net_device *dev, u32 a)
{
	u8 conf3;

	rtl8180_set_mode(dev, EPROM_CMD_CONFIG);

	conf3 = read_nic_byte(dev, CONFIG3);
	write_nic_byte(dev, CONFIG3, conf3 | (1<<CONFIG3_ANAPARAM_W_SHIFT));	

	write_nic_dword(dev, ANAPARAM2, a);

	conf3 = read_nic_byte(dev, CONFIG3);
	write_nic_byte(dev, CONFIG3, conf3 &~(1<<CONFIG3_ANAPARAM_W_SHIFT));

	rtl8180_set_mode(dev, EPROM_CMD_NORMAL);

}


void rtl8180_set_anaparam(struct net_device *dev, u32 a)
{
	u8 conf3;

	rtl8180_set_mode(dev, EPROM_CMD_CONFIG);

	conf3 = read_nic_byte(dev, CONFIG3);
	write_nic_byte(dev, CONFIG3, conf3 | (1<<CONFIG3_ANAPARAM_W_SHIFT));
	
	write_nic_dword(dev, ANAPARAM, a);

	conf3 = read_nic_byte(dev, CONFIG3);
	write_nic_byte(dev, CONFIG3, conf3 &~(1<<CONFIG3_ANAPARAM_W_SHIFT));

	rtl8180_set_mode(dev, EPROM_CMD_NORMAL);
	
}


void rtl8185_tx_antenna(struct net_device *dev, u8 ant)
{
	write_nic_byte(dev, ANTSEL, ant); 
	force_pci_posting(dev);
	mdelay(1);
}	


void rtl8187_write_phy(struct net_device *dev, u8 adr, u32 data)
{
	//u8 phyr;
	u32 phyw;
//	int i;
	
	adr |= 0x80;
	 
	phyw= ((data<<8) | adr);
	
	
	
	// Note that, we must write 0xff7c after 0x7d-0x7f to write BB register. 
	write_nic_byte(dev, 0x7f, ((phyw & 0xff000000) >> 24));
	write_nic_byte(dev, 0x7e, ((phyw & 0x00ff0000) >> 16));
	write_nic_byte(dev, 0x7d, ((phyw & 0x0000ff00) >> 8));
	write_nic_byte(dev, 0x7c, ((phyw & 0x000000ff) ));

	//read_nic_dword(dev, PHY_ADR);
#if 0	
	for(i=0;i<10;i++){
		write_nic_dword(dev, PHY_ADR, 0xffffff7f & phyw);
		phyr = read_nic_byte(dev, PHY_READ);
		if(phyr == (data&0xff)) break;
			
	}
#endif
	/* this is ok to fail when we write AGC table. check for AGC table might be
	 * done by masking with 0x7f instead of 0xff
	 */
	//if(phyr != (data&0xff)) DMESGW("Phy write timeout %x %x %x", phyr, data, adr);
	mdelay(1);
}

u8 rtl8187_read_phy(struct net_device *dev,u8 adr, u32 data)
{
	u32 phyw;

	adr &= ~0x80;
	phyw= ((data<<8) | adr);
	
	
	// Note that, we must write 0xff7c after 0x7d-0x7f to write BB register. 
	write_nic_byte(dev, 0x7f, ((phyw & 0xff000000) >> 24));
	write_nic_byte(dev, 0x7e, ((phyw & 0x00ff0000) >> 16));
	write_nic_byte(dev, 0x7d, ((phyw & 0x0000ff00) >> 8));
	write_nic_byte(dev, 0x7c, ((phyw & 0x000000ff) ));
	
	return(read_nic_byte(dev,0x7e));

}

u8 read_phy_ofdm(struct net_device *dev, u8 adr)
{
	return(rtl8187_read_phy(dev, adr, 0x000000));
}

u8 read_phy_cck(struct net_device *dev, u8 adr)
{
	return(rtl8187_read_phy(dev, adr, 0x10000));
}

inline void write_phy_ofdm (struct net_device *dev, u8 adr, u32 data)
{
	data = data & 0xff;
	rtl8187_write_phy(dev, adr, data);
}


void write_phy_cck (struct net_device *dev, u8 adr, u32 data)
{
	data = data & 0xff;
	rtl8187_write_phy(dev, adr, data | 0x10000);
}



void rtl8180_adapter_start(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	struct ieee80211_device *ieee = priv->ieee80211;
	u8			InitWirelessMode;
	u8			SupportedWirelessMode;
	bool			bInvalidWirelessMode = false;	


	if(NIC_8187 == priv->card_8187) {
		//rtl8180_rtx_disable(dev);
		rtl8180_reset(dev);

		write_nic_byte(dev,0x85,0);
		write_nic_byte(dev,0x91,0);

		/* light blink! */
		write_nic_byte(dev,0x85,4);
		write_nic_byte(dev,0x91,1);
		write_nic_byte(dev,0x90,0);
		/*	
			write_nic_byte(dev, CR9346, 0xC0);
		//LED TYPE
		write_nic_byte(dev, CONFIG1,((read_nic_byte(dev, CONFIG1)&0x3f)|0x80));	//turn on bit 5:Clkrun_mode
		write_nic_byte(dev, CR9346, 0x0);	// disable config register write
		*/	
		priv->irq_mask = 0xffff;
		/*
		   priv->dma_poll_mask = 0;
		   priv->dma_poll_mask|= (1<<TX_DMA_STOP_BEACON_SHIFT);
		   */	
		//	rtl8180_beacon_tx_disable(dev);

		rtl8180_set_mode(dev, EPROM_CMD_CONFIG);
		write_nic_dword(dev, MAC0, ((u32*)dev->dev_addr)[0]);
		write_nic_word(dev, MAC4, ((u32*)dev->dev_addr)[1] & 0xffff );

		rtl8180_set_mode(dev, EPROM_CMD_NORMAL);
		rtl8180_update_msr(dev);

		rtl8180_set_mode(dev, EPROM_CMD_CONFIG);

		write_nic_word(dev,0xf4,0xffff);
		write_nic_byte(dev,
				CONFIG1, (read_nic_byte(dev,CONFIG1) & 0x3f) | 0x80);	

		rtl8180_set_mode(dev,EPROM_CMD_NORMAL);

		write_nic_dword(dev,INT_TIMEOUT,0);	

#ifdef DEBUG_REGISTERS
		rtl8180_dump_reg(dev);	
#endif


		write_nic_byte(dev, WPA_CONFIG, 0);	

		write_nic_byte(dev, RATE_FALLBACK, 0x81);
		rtl8187_set_rate(dev);

		priv->rf_init(dev);	

		if(priv->rf_set_sens != NULL) {
			priv->rf_set_sens(dev,priv->sens);	
		}

		write_nic_word(dev,0x5e,1);
		//mdelay(1);
		write_nic_word(dev,0xfe,0x10);
		//	mdelay(1);
		write_nic_byte(dev, TALLY_SEL, 0x80);//Set NQ retry count
		write_nic_byte(dev, 0xff, 0x60);
		write_nic_word(dev,0x5e,0);

		rtl8180_irq_enable(dev);
	} else {
		/**
		 *  IO part migrated from Windows Driver.
		 */
		priv->irq_mask = 0xffff;
		// Enable Config3.PARAM_En.
		write_nic_byte(dev, CR9346, 0xC0);

		write_nic_byte(dev, CONFIG3, (read_nic_byte(dev, CONFIG3)| CONFIG3_PARM_En|CONFIG3_GNTSel));
		// Turn on Analog power.
		// setup A/D D/A parameter for 8185 b2 
		// Asked for by William, otherwise, MAC 3-wire can't work, 2006.06.27, by rcnjko.
		write_nic_dword(dev, ANA_PARAM2, ANAPARM2_ASIC_ON);
		write_nic_dword(dev, ANA_PARAM, ANAPARM_ASIC_ON);
		write_nic_byte(dev, ANA_PARAM3, 0x00);

		write_nic_byte(dev, CONFIG3, (read_nic_byte(dev, CONFIG3)&(~CONFIG3_PARM_En)));
		write_nic_byte(dev, CR9346, 0x00);

		//rtl8180_rtx_disable(dev);
		rtl8180_reset(dev);

		write_nic_byte(dev, CR9346, 0xc0);	// enable config register write
                priv->rf_init(dev);                
		// Enable tx/rx
		write_nic_byte(dev, CMD, (CR_RE|CR_TE));// Using HW_VAR_COMMAND instead of writing CMDR directly. Rewrited by Annie, 2006-04-07.

		rtl8180_irq_enable(dev);
		//add this is for 8187B Rx stall problem
		write_nic_byte_E(dev, 0x41, 0xF4);
		write_nic_byte_E(dev, 0x40, 0x00);
		write_nic_byte_E(dev, 0x42, 0x00);
		write_nic_byte_E(dev, 0x42, 0x01);
		write_nic_byte_E(dev, 0x40, 0x0F);
		write_nic_byte_E(dev, 0x42, 0x00);
		write_nic_byte_E(dev, 0x42, 0x01);
		 
	}
}

/* this configures registers for beacon tx and enables it via
 * rtl8180_beacon_tx_enable(). rtl8180_beacon_tx_disable() might
 * be used to stop beacon transmission
 */
#if 0
void rtl8180_start_tx_beacon(struct net_device *dev)
{
	int i;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	u16 word;	
	DMESG("Enabling beacon TX");
	//write_nic_byte(dev, 0x42,0xe6);// TCR
	//rtl8180_init_beacon(dev);
	//set_nic_txring(dev);
//	rtl8180_prepare_beacon(dev);
	rtl8180_irq_disable(dev);
//	rtl8180_beacon_tx_enable(dev);
	rtl8180_set_mode(dev,EPROM_CMD_CONFIG);
	//write_nic_byte(dev,0x9d,0x20); //DMA Poll
	//write_nic_word(dev,0x7a,0);
	//write_nic_word(dev,0x7a,0x8000);

	
	word  = read_nic_word(dev, BcnItv);
	word &= ~BcnItv_BcnItv; // clear Bcn_Itv
	write_nic_word(dev, BcnItv, word);

	write_nic_word(dev, AtimWnd, 
		       read_nic_word(dev, AtimWnd) &~ AtimWnd_AtimWnd);
	
	word  = read_nic_word(dev, BintrItv);
	word &= ~BintrItv_BintrItv;
	
	//word |= priv->ieee80211->beacon_interval * 
	//	((priv->txbeaconcount > 1)?(priv->txbeaconcount-1):1);
	// FIXME:FIXME check if correct ^^ worked with 0x3e8;
	
	write_nic_word(dev, BintrItv, word);
	
	//write_nic_word(dev,0x2e,0xe002);
	//write_nic_dword(dev,0x30,0xb8c7832e);
	for(i=0; i<ETH_ALEN; i++)
		write_nic_byte(dev, BSSID+i, priv->ieee80211->beacon_cell_ssid[i]);
	
//	rtl8180_update_msr(dev);

	
	//write_nic_byte(dev,CONFIG4,3); /* !!!!!!!!!! */
	
	rtl8180_set_mode(dev, EPROM_CMD_NORMAL);
	
	rtl8180_irq_enable(dev);
	
	/* VV !!!!!!!!!! VV*/
	/*
	rtl8180_set_mode(dev,EPROM_CMD_CONFIG);
	write_nic_byte(dev,0x9d,0x00); 	
	rtl8180_set_mode(dev,EPROM_CMD_NORMAL);
*/
}
#endif
/***************************************************************************
    -------------------------------NET STUFF---------------------------
***************************************************************************/
static struct net_device_stats *rtl8180_stats(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	
	return &priv->ieee80211->stats;
}


int _rtl8180_up(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	//int i;

	priv->up=1;
	
	//DMESG("Bringing up iface");
	rtl8180_adapter_start(dev);
	rtl8180_rx_enable(dev);
	rtl8180_tx_enable(dev);

	ieee80211_softmac_start_protocol(priv->ieee80211);
	ieee80211_reset_queue(priv->ieee80211);

	if(!netif_queue_stopped(dev))
		netif_start_queue(dev);
	else
		netif_wake_queue(dev);

	return 0;
}


int rtl8180_open(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	int ret;
	
	down(&priv->wx_sem);
	ret = rtl8180_up(dev);
	up(&priv->wx_sem);
	return ret;
	
}


int rtl8180_up(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);

	if (priv->up == 1) return -1;
	
	return _rtl8180_up(dev);
}


int rtl8180_close(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	int ret;
	
	down(&priv->wx_sem);

	printk(KERN_WARNING "rtl8180_close process \n");
	ret = rtl8180_down(dev);
	
	up(&priv->wx_sem);
	
	return ret;

}

int rtl8180_down(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);

	if (priv->up == 0) return -1;
	
	priv->up=0;

/* FIXME */
	if (!netif_queue_stopped(dev))
		netif_stop_queue(dev);
	
	printk(KERN_WARNING "rtl8180_down process \n");
	rtl8180_rtx_disable(dev);
	rtl8180_irq_disable(dev);

	ieee80211_softmac_stop_protocol(priv->ieee80211);
		
	return 0;
}


void rtl8180_commit(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);

	if (priv->up == 0) return ;

	printk(KERN_WARNING "rtl8180_commit process!\n");

	ieee80211_softmac_stop_protocol(priv->ieee80211);
	
	rtl8180_irq_disable(dev);
	rtl8180_rtx_disable(dev);
	_rtl8180_up(dev);
}

#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,20))
void rtl8180_restart(struct work_struct *work)
{
	struct r8180_priv *priv = container_of(work, struct r8180_priv, reset_wq);
	struct net_device *dev = priv->dev;
#else
void rtl8180_restart(struct net_device *dev)
{

	struct r8180_priv *priv = ieee80211_priv(dev);
#endif

	down(&priv->wx_sem);
	
	rtl8180_commit(dev);
	
	up(&priv->wx_sem);
}

static void r8180_set_multicast(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	short promisc;

	//down(&priv->wx_sem);
	
	/* FIXME FIXME */
	
	promisc = (dev->flags & IFF_PROMISC) ? 1:0;
	
	if (promisc != priv->promisc)
	//	rtl8180_commit(dev);
	
	priv->promisc = promisc;
	
	//schedule_work(&priv->reset_wq);
	//up(&priv->wx_sem);
}


int r8180_set_mac_adr(struct net_device *dev, void *mac)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	struct sockaddr *addr = mac;
	
	down(&priv->wx_sem);
	
	memcpy(dev->dev_addr, addr->sa_data, ETH_ALEN);
		
#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0))
	schedule_work(&priv->reset_wq);
#else
	schedule_task(&priv->reset_wq);
#endif	
	up(&priv->wx_sem);
	
	return 0;
}

/* based on ipw2200 driver */
int rtl8180_ioctl(struct net_device *dev, struct ifreq *rq, int cmd)
{
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	struct iwreq *wrq = (struct iwreq *)rq;
	int ret=-1;

	down(&priv->wx_sem);

	switch (cmd) {
	    case RTL_IOCTL_WPA_SUPPLICANT:
		ret = ieee80211_wpa_supplicant_ioctl(priv->ieee80211, &wrq->u.data);
		break; 

	    default:
		ret = -EOPNOTSUPP;
		break;
	}

	up(&priv->wx_sem);
	
	return ret;
}


struct tx_desc {

#ifdef _LINUX_BYTEORDER_LITTLE_ENDIAN_H


//dword 0
unsigned int    tpktsize:12;
unsigned int    rsvd0:3;
unsigned int    no_encrypt:1;
unsigned int    splcp:1;
unsigned int    morefrag:1;
unsigned int    ctsen:1;
unsigned int    rtsrate:4;
unsigned int    rtsen:1;
unsigned int    txrate:4;
unsigned int	last:1;
unsigned int	first:1;
unsigned int	dmaok:1;
unsigned int	own:1;

//dword 1
unsigned short  rtsdur;
unsigned short  length:15;
unsigned short  l_ext:1;

//dword 2
unsigned int	bufaddr;


//dword 3
unsigned short	rxlen:12;
unsigned short  rsvd1:3;
unsigned short  miccal:1;
unsigned short	dur;

//dword 4
unsigned int	nextdescaddr;

//dword 5
unsigned char	rtsagc;
unsigned char	retrylimit;
unsigned short	rtdb:1;
unsigned short	noacm:1;
unsigned short	pifs:1;
unsigned short	rsvd2:4;
unsigned short	rtsratefallback:4;
unsigned short	ratefallback:5;

//dword 6
unsigned short	delaybound;
unsigned short	rsvd3:4;
unsigned short	agc:8;
unsigned short	antenna:1;
unsigned short	spc:2;
unsigned short	rsvd4:1;

//dword 7
unsigned char	len_adjust:2;
unsigned char	rsvd5:1;
unsigned char	tpcdesen:1;
unsigned char	tpcpolarity:2;
unsigned char	tpcen:1;
unsigned char	pten:1;

unsigned char	bckey:6;
unsigned char	enbckey:1;
unsigned char	enpmpd:1;
unsigned short	fragqsz;


#else

#error "please modify tx_desc to your own\n"

#endif


} __attribute__((packed));

struct rx_desc_rtl8187b {

#ifdef _LINUX_BYTEORDER_LITTLE_ENDIAN_H

//dword 0
unsigned int	rxlen:12;
unsigned int	icv:1;
unsigned int	crc32:1;
unsigned int	pwrmgt:1;
unsigned int	res:1;
unsigned int	bar:1;
unsigned int	pam:1;
unsigned int	mar:1;
unsigned int	qos:1;
unsigned int	rxrate:4;
unsigned int	trsw:1;
unsigned int	splcp:1;
unsigned int	fovf:1;
unsigned int	dmafail:1;
unsigned int	last:1;
unsigned int	first:1;
unsigned int	eor:1;
unsigned int	own:1;


//dword 1
unsigned int	tsftl;


//dword 2
unsigned int	tsfth;


//dword 3
unsigned char	sq;
unsigned char	rssi:7;
unsigned char	antenna:1;

unsigned char	agc;
unsigned char 	decrypted:1;
unsigned char	wakeup:1;
unsigned char	shift:1;
unsigned char	rsvd0:5;

//dword 4
unsigned int	num_mcsi:4;
unsigned int	snr_long2end:6;
unsigned int	cfo_bias:6;

unsigned int	pwdb_g12:8;
unsigned int	fot:8;




#else

#error "please modify tx_desc to your own\n"

#endif

}__attribute__((packed));



struct rx_desc_rtl8187 {

#ifdef _LINUX_BYTEORDER_LITTLE_ENDIAN_H

//dword 0
unsigned int    rxlen:12;
unsigned int    icv:1;
unsigned int    crc32:1;
unsigned int    pwrmgt:1;
unsigned int    res:1;
unsigned int    bar:1;
unsigned int    pam:1;
unsigned int    mar:1;
unsigned int    qos:1;
unsigned int    rxrate:4;
unsigned int    trsw:1;
unsigned int    splcp:1;
unsigned int    fovf:1;
unsigned int    dmafail:1;
unsigned int    last:1;
unsigned int    first:1;
unsigned int    eor:1;
unsigned int    own:1;

//dword 1
unsigned char   sq;
unsigned char   rssi:7;
unsigned char   antenna:1;

unsigned char   agc;
unsigned char   decrypted:1;
unsigned char   wakeup:1;
unsigned char   shift:1;
unsigned char   rsvd0:5;

//dword 2
unsigned int tsftl;

//dword 3
unsigned int tsfth;



#else

#error "please modify tx_desc to your own\n"

#endif


}__attribute__((packed));



union rx_desc {

struct	rx_desc_rtl8187b desc_87b;
struct	rx_desc_rtl8187	 desc_87;

}__attribute__((packed));

#ifndef JACKSON_NEW_RX

void rtl8180_irq_rx_tasklet(struct r8180_priv *priv)
{
	struct urb *rx_urb = priv->rxurb_task;
	struct net_device *dev = (struct net_device*)rx_urb->context;
	int status,len,flen;
	struct sk_buff *skb;
	union	rx_desc *desc;

	//DMESG("rtl8187_rx_isr");

	struct ieee80211_rx_stats stats = {
		.signal = 0,
		.noise = -98,
		.rate = 0,
		//	.mac_time = jiffies,
		.freq = IEEE80211_24GHZ_BAND,
	};

	//DMESG("RX %d ",rx_urb->status);
	status = rx_urb->status;
	if(status == 0)
	{
		if(NIC_8187B == priv->card_8187) 
		{
			stats.nic_type = NIC_8187B;
			len = rx_urb->actual_length;
			//	len = len - 4 - 15 - 1; /* CRC, DESC, SEPARATOR*/ 
			//len -= 4*4;/* 4 dword and 4 byte CRC */
			//len -= 5*4;/* 4 dword and 4 byte CRC */

			len -= sizeof (struct rx_desc_rtl8187b);

			desc = (union rx_desc *)(rx_urb->transfer_buffer + len);
			
			flen = desc->desc_87b.rxlen ;
			
			if( flen <= rx_urb->actual_length){

				stats.mac_time[0] = desc->desc_87b.tsftl;
				stats.mac_time[1] = desc->desc_87b.tsfth;

				stats.signal = desc->desc_87b.rssi;
				stats.noise = desc->desc_87b.sq;
				stats.rate = desc->desc_87b.rxrate;
				skb = dev_alloc_skb(flen-4);
				//skb_reserve(skb,2);
				if(skb){ 
					//shift start address according to shift bits.
					//memcpy(skb_put(skb,flen-4),
					//	rx_urb->transfer_buffer+((desc[3]&0x0400)?2:0),flen -4);
					memcpy(skb_put(skb,flen-4),
							rx_urb->transfer_buffer,flen -4);

#ifdef DUMP_RX
					int i;
					for(i=0;i<flen-4;i++)
						printk("%2x ",((u8*)(rx_urb->transfer_buffer))[i]);
					printk("------RATE %x:w---------------\n",stats.rate);

#endif
					priv->stats.rxok++;
					//	priv->rxskb = skb;
					//	priv->tempstats = &stats;

					if(!ieee80211_rx(priv->ieee80211, 
								skb, &stats))
						dev_kfree_skb_any(skb);
				}
			}else priv->stats.rxurberr++;
		} else {
			stats.nic_type = NIC_8187;
			len = rx_urb->actual_length;
			//	len = len - 4 - 15 - 1; /* CRC, DESC, SEPARATOR*/ 
			//len -= 4*4;/* 4 dword and 4 byte CRC */
			len -= sizeof (struct rx_desc_rtl8187);

			desc = (union rx_desc *)(rx_urb->transfer_buffer + len);

			flen = desc->desc_87.rxlen ;

			if( flen <= rx_urb->actual_length){
				stats.signal = desc->desc_87.rssi;
				stats.noise = desc->desc_87.sq;
				stats.rate = desc->desc_87.rxrate;
				stats.mac_time[0] = desc->desc_87.tsftl;
				stats.mac_time[1] = desc->desc_87.tsfth;
				skb = dev_alloc_skb(flen-4);
				//skb_reserve(skb,2);
				if(skb){ 
					memcpy(skb_put(skb,flen-4),
							rx_urb->transfer_buffer,flen -4);

#ifdef DUMP_RX
					int i;
					for(i=0;i<flen-4;i++)
						printk("%2x ",((u8*)(rx_urb->transfer_buffer))[i]);
					printk("------RATE %x:w---------------\n",stats.rate);

#endif
					priv->stats.rxok++;
					//	priv->rxskb = skb;
					//	priv->tempstats = &stats;

					if(!ieee80211_rx(priv->ieee80211, 
								skb, &stats))
						dev_kfree_skb_any(skb);
				}
			}else priv->stats.rxurberr++;
		}	
	}else{
		priv->stats.rxstaterr++;
		priv->ieee80211->stats.rx_errors++;

	}

	if(status != -ENOENT)
		rtl8187_rx_urbsubmit(dev,rx_urb);
	else 
		DMESG("RX process aborted due to explicit shutdown");
}



#else

#ifdef THOMAS_SKB

void rtl8180_irq_rx_tasklet(struct r8180_priv *priv)
{
        int status,len,flen;
        
	int *prx_inx;

        struct sk_buff *skb;	
        struct sk_buff *skb2;//skb for check out of memory
	
        union   rx_desc *desc;
	
	//struct urb *rx_urb = priv->rxurb_task;
	struct urb *rx_urb;
	prx_inx = &priv->rx_inx;
	rx_urb = priv->rx_urb[*prx_inx]; //changed by jackson

	struct net_device *dev = (struct net_device*)rx_urb->context;

        struct ieee80211_rx_stats stats = {
                .signal = 0,
                .noise = -98,
                .rate = 0,
                //      .mac_time = jiffies,
                .freq = IEEE80211_24GHZ_BAND,
        };

        //DMESG("RX %d ",rx_urb->status);

        skb = priv->pp_rxskb[*prx_inx];

        status = rx_urb->status;

	skb2 = dev_alloc_skb(RX_URB_SIZE);

	if (skb2 == NULL){
        	printk(KERN_ALERT "No Skb For RX!/n");
		//rx_urb->transfer_buffer = skb->data;
        	//priv->pp_rxskb[*prx_inx] = skb;
	} else {
        
	if(status == 0)
        {
                if(NIC_8187B == priv->card_8187)
                {
                        stats.nic_type = NIC_8187B;
                        
			len = rx_urb->actual_length;

                        len -= sizeof (struct rx_desc_rtl8187b);

                        desc = (union rx_desc *)(rx_urb->transfer_buffer + len);

                        flen = desc->desc_87b.rxlen ;

                        if( flen <= rx_urb->actual_length){

                                stats.mac_time[0] = desc->desc_87b.tsftl;
                                stats.mac_time[1] = desc->desc_87b.tsfth;

                                stats.signal = desc->desc_87b.rssi;
                                stats.noise = desc->desc_87b.sq;
                                stats.rate = desc->desc_87b.rxrate;
                               
				skb_put(skb,flen-4);
 
                                priv->stats.rxok++;

                                if(!ieee80211_rx(priv->ieee80211,skb, &stats)) {
                                	dev_kfree_skb_any(skb);
                                }
                        }else {
				priv->stats.rxurberr++;
				printk("URB Error  flen:%d actual_length:%d\n",  flen , rx_urb->actual_length);
                        	dev_kfree_skb_any(skb);
			}
                } else {
                        
			stats.nic_type = NIC_8187;
                        
			len = rx_urb->actual_length;
                        
			len -= sizeof (struct rx_desc_rtl8187);

                        desc = (union rx_desc *)(rx_urb->transfer_buffer + len);

                        flen = desc->desc_87.rxlen ;

                        if(flen <= rx_urb->actual_length){
                                stats.signal = desc->desc_87.rssi;
                                stats.noise = desc->desc_87.sq;
                                stats.rate = desc->desc_87.rxrate;
                                stats.mac_time[0] = desc->desc_87.tsftl;
                                stats.mac_time[1] = desc->desc_87.tsfth;


				skb_put(skb,flen-4);

                                priv->stats.rxok++;

                                if(!ieee80211_rx(priv->ieee80211,skb, &stats))
                                        dev_kfree_skb_any(skb);


                        }else {
			 	priv->stats.rxurberr++;
                                printk("URB Error  flen:%d actual_length:%d\n",  flen , rx_urb->actual_length);
                                dev_kfree_skb_any(skb);
			} 
                }
        }else{

		printk("RX Status Error!\n");
                priv->stats.rxstaterr++;
                priv->ieee80211->stats.rx_errors++;
                dev_kfree_skb_any(skb);

        }	

        rx_urb->transfer_buffer = skb2->data;

        priv->pp_rxskb[*prx_inx] = skb2;
        }

	if(status == 0)
                rtl8187_rx_urbsubmit(dev,rx_urb);
        else {
                priv->pp_rxskb[*prx_inx] = NULL;
                dev_kfree_skb_any(skb2);
                printk("RX process aborted due to explicit shutdown (%x) ", status);
        }

       if (*prx_inx == (MAX_RX_URB -1))
                *prx_inx = 0;
       else
                *prx_inx = *prx_inx + 1;
}

#else

void rtl8180_irq_rx_tasklet(struct r8180_priv *priv)
{
        int status,len,flen;
        
	int *prx_inx;

        struct sk_buff *skb;

        union   rx_desc *desc;
	
	//struct urb *rx_urb = priv->rxurb_task;
	struct urb *rx_urb;
	prx_inx = &priv->rx_inx;
	rx_urb = priv->rx_urb[*prx_inx]; //changed by jackson

	struct net_device *dev = (struct net_device*)rx_urb->context;

        struct ieee80211_rx_stats stats = {
                .signal = 0,
                .noise = -98,
                .rate = 0,
                //      .mac_time = jiffies,
                .freq = IEEE80211_24GHZ_BAND,
        };

        //DMESG("RX %d ",rx_urb->status);


        skb = priv->pp_rxskb[*prx_inx];

        status = rx_urb->status;
        
	if(status == 0)
        {
                if(NIC_8187B == priv->card_8187)
                {
                        stats.nic_type = NIC_8187B;
                        
			len = rx_urb->actual_length;

                        len -= sizeof (struct rx_desc_rtl8187b);

                        desc = (union rx_desc *)(rx_urb->transfer_buffer + len);

                        flen = desc->desc_87b.rxlen ;

                        if( flen <= rx_urb->actual_length){

                                stats.mac_time[0] = desc->desc_87b.tsftl;
                                stats.mac_time[1] = desc->desc_87b.tsfth;

                                stats.signal = desc->desc_87b.rssi;
                                stats.noise = desc->desc_87b.sq;
                                stats.rate = desc->desc_87b.rxrate;
                               
				skb_put(skb,flen-4);
 
                                priv->stats.rxok++;

                                if(!ieee80211_rx(priv->ieee80211,skb, &stats)) {
                                	dev_kfree_skb_any(skb);
                                }
                        }else {
				priv->stats.rxurberr++;
				printk("URB Error  flen:%d actual_length:%d\n",  flen , rx_urb->actual_length);
                        	dev_kfree_skb_any(skb);
			}
                } else {
                        
			stats.nic_type = NIC_8187;
                        
			len = rx_urb->actual_length;
                        
			len -= sizeof (struct rx_desc_rtl8187);

                        desc = (union rx_desc *)(rx_urb->transfer_buffer + len);

                        flen = desc->desc_87.rxlen ;

                        if(flen <= rx_urb->actual_length){
                                stats.signal = desc->desc_87.rssi;
                                stats.noise = desc->desc_87.sq;
                                stats.rate = desc->desc_87.rxrate;
                                stats.mac_time[0] = desc->desc_87.tsftl;
                                stats.mac_time[1] = desc->desc_87.tsfth;


				skb_put(skb,flen-4);

                                priv->stats.rxok++;

                                if(!ieee80211_rx(priv->ieee80211,skb, &stats))
                                        dev_kfree_skb_any(skb);


                        }else {
			 	priv->stats.rxurberr++;
                                printk("URB Error  flen:%d actual_length:%d\n",  flen , rx_urb->actual_length);
                                dev_kfree_skb_any(skb);
			} 
                }
        }else{

		printk("RX Status Error!\n");
                priv->stats.rxstaterr++;
                priv->ieee80211->stats.rx_errors++;
                dev_kfree_skb_any(skb);

        }
	

	skb = dev_alloc_skb(RX_URB_SIZE);
        if (skb == NULL)
                panic("No Skb For RX!/n");

        rx_urb->transfer_buffer = skb->data;

        priv->pp_rxskb[*prx_inx] = skb;

        if(status == 0)
                rtl8187_rx_urbsubmit(dev,rx_urb);
        else {
                priv->pp_rxskb[*prx_inx] = NULL;
                dev_kfree_skb_any(skb);
                printk("RX process aborted due to explicit shutdown (%x) ", status);
        }

       if (*prx_inx == (MAX_RX_URB -1))
                *prx_inx = 0;
       else
                *prx_inx = *prx_inx + 1;

}
#endif

#endif

#ifdef THOMAS_TASKLET
void rtl8180_irq_rx_tasklet_new(struct r8180_priv *priv){
	while( atomic_read( &priv->irt_counter ) ){
		rtl8180_irq_rx_tasklet(priv);
		atomic_dec( &priv->irt_counter );
	}
}
#endif
/****************************************************************************
     ---------------------------- USB_STUFF---------------------------
*****************************************************************************/

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
static int __devinit rtl8187_usb_probe(struct usb_interface *intf,
			 const struct usb_device_id *id)
#else
static void * __devinit rtl8187_usb_probe(struct usb_device *udev,
			                unsigned int ifnum,
			          const struct usb_device_id *id)
#endif
{
//	unsigned long ioaddr = 0;
	struct net_device *dev = NULL;
	struct r8180_priv *priv= NULL;
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
	struct usb_device *udev = interface_to_usbdev(intf);
#endif

	dev = alloc_ieee80211(sizeof(struct r8180_priv));
	
	SET_MODULE_OWNER(dev);

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
	usb_set_intfdata(intf, dev);	
	SET_NETDEV_DEV(dev, &intf->dev);
#endif
	priv = ieee80211_priv(dev);
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
	priv->ieee80211 = netdev_priv(dev);
#else
	priv->ieee80211 = (struct net_device *)dev->priv;
#endif
	priv->udev=udev;
	
	dev->open = rtl8180_open;
	dev->stop = rtl8180_close;
	//dev->hard_start_xmit = rtl8180_8023_hard_start_xmit;
	dev->tx_timeout = tx_timeout;
	dev->wireless_handlers = &r8180_wx_handlers_def;
	dev->do_ioctl = rtl8180_ioctl;
	dev->set_multicast_list = r8180_set_multicast;
	dev->set_mac_address = r8180_set_mac_adr;
#if WIRELESS_EXT >= 12
#if WIRELESS_EXT < 17
	dev->get_wireless_stats = r8180_get_wireless_stats;
#endif
	dev->wireless_handlers = (struct iw_handler_def *) &r8180_wx_handlers_def;
#endif
	
	//dev->get_wireless_stats = r8180_get_wireless_stats;
	dev->type=ARPHRD_ETHER;
	
	if (dev_alloc_name(dev, ifname) < 0){
                DMESG("Oops: devname already taken! Trying wlan%%d...\n");
		ifname = "wlan%d";
		dev_alloc_name(dev, ifname);
        }
	
//	dev->open=rtl8180_init;
	
	if(rtl8180_init(dev)!=0){ 
		DMESG("Initialization failed");
		goto fail;
	}
	
	netif_carrier_off(dev);
	netif_stop_queue(dev);
	
	register_netdev(dev);
	
	rtl8180_proc_init_one(dev);
	
	
	DMESG("Driver probe completed\n");
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
	return dev;
#else
	return 0;	
#endif

	
fail:
	free_ieee80211(dev);
		
	DMESG("wlan driver load failed\n");
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)	
	return NULL;
#else
	return -ENODEV;
#endif
	
}

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0) 
static void __devexit rtl8187_usb_disconnect(struct usb_interface *intf)
#else 
static void __devexit rtl8187_usb_disconnect(struct usb_device *udev, void *ptr)
#endif
{
	struct r8180_priv *priv;
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
	struct net_device *dev = usb_get_intfdata(intf);
#else
	struct net_device *dev = (struct net_device *)ptr;
#endif
 	if(dev){
		
		unregister_netdev(dev);
		
		priv=ieee80211_priv(dev);
		
		rtl8180_proc_remove_one(dev);
		
		rtl8180_down(dev);
		priv->rf_close(dev);
		//rtl8180_rtx_disable(dev);
		rtl8187_usb_deleteendpoints(dev);
		rtl8180_irq_disable(dev);
		rtl8180_reset(dev);
		mdelay(10);

	}
//	pci_disable_device(pdev);
	free_ieee80211(dev);
	DMESG("wlan driver removed\n");
}


static int __init rtl8187_usb_module_init(void)
{
	printk(KERN_INFO "\nLinux kernel driver for RTL8187/RTL8187B \
based WLAN cards\n");
	printk(KERN_INFO "Copyright (c) 2004-2005, Andrea Merello\n");
	DMESG("Initializing module");
	DMESG("Wireless extensions version %d", WIRELESS_EXT);
	rtl8180_proc_module_init();
	return usb_register(&rtl8187_usb_driver);
}


static void __exit rtl8187_usb_module_exit(void)
{
	usb_deregister(&rtl8187_usb_driver);

	rtl8180_proc_module_remove();
	DMESG("Exiting");
}


void rtl8180_try_wake_queue(struct net_device *dev, int pri)
{
	unsigned long flags;
	short enough_desc;
	struct r8180_priv *priv = (struct r8180_priv *)ieee80211_priv(dev);
	
	spin_lock_irqsave(&priv->tx_lock,flags);
	enough_desc = check_nic_enought_desc(dev,pri);
        spin_unlock_irqrestore(&priv->tx_lock,flags);	
	
	if(enough_desc)
		ieee80211_wake_queue(priv->ieee80211);
}



/***************************************************************************
     ------------------- module init / exit stubs ----------------
****************************************************************************/
module_init(rtl8187_usb_module_init);
module_exit(rtl8187_usb_module_exit);
